import gulp     from "gulp";
import gulpIf   from "gulp-if";
import uglify   from "gulp-uglify";
import replace  from "gulp-replace";
import TaskEnvConfig from "../config/task.config.js";


gulp.task('js:app',['js:app:pro']);

// app.js
gulp.task('js:app:dev','app脚本的处理',function(){
  return appjsTask(TaskEnvConfig,'dev');
});

// app.js
gulp.task('js:app:test',['js:app:dev'],function(){
  return appjsTask(TaskEnvConfig,'test');
});


// app.js
gulp.task('js:app:uat',['js:app:test'],function(){
  return appjsTask(TaskEnvConfig,'uat');
});

// app.js
gulp.task('js:app:pro',['js:app:uat'],function(){
  return appjsTask(TaskEnvConfig,'pro');
});

function appjsTask(globalConfigs,env){

  var config = globalConfigs[env];
  return gulp.src('./static/require.config.js')
    .pipe(replace('${baseUrl}',config.baseUrl))
    .pipe(replace('${version}',globalConfigs.version))
    .pipe(gulpIf(env!='dev',uglify({
      mangle:false
    })))
    .pipe(gulp.dest(config.dest+'/'+globalConfigs.version+'/static/'));
};