import gulp           from "gulp";
import gulpIf         from "gulp-if";
import minifyCss      from "gulp-minify-css"
import TaskEnvConfig  from "../config/task.config.js";


gulp.task('style:dev',function(){
  return styleTask(TaskEnvConfig,'dev');
});

gulp.task('css:dev',function(){
  return cssTask(TaskEnvConfig,'dev');
});

gulp.task('style:test',['style:dev'],function(){
  return styleTask(TaskEnvConfig,'test');
});

gulp.task('css:test',['css:dev'],function(){
  return cssTask(TaskEnvConfig,'test');
});

gulp.task('style:uat',['style:test'],function(){
  return styleTask(TaskEnvConfig,'uat');
});

gulp.task('css:uat',['css:test'],function(){
  return cssTask(TaskEnvConfig,'uat');
});

gulp.task('style:pro',['style:uat'],function(){
  return styleTask(TaskEnvConfig,'pro');
});

gulp.task('css:pro',['css:uat'],function(){
  return cssTask(TaskEnvConfig,'pro');
});

gulp.task('css-style',['css:pro','style:pro']);




function cssTask(globalConfigs,env){
  var config = globalConfigs[env];
  return gulp.src('./static/css/**/*')
  .pipe(gulpIf(env != 'dev',minifyCss()))
  .pipe(gulp.dest(config.dest+'/'+globalConfigs.version+'/static/css/'))
}


function styleTask(globalConfigs,env){
  var config = globalConfigs[env];
  var src = ['./static/style/**/*'];
  return  gulp.src(src)
  .pipe(minifyCss())
  .pipe(gulp.dest(config.dest+'/'+globalConfigs.version+'/static/style/'))
}