import gulp       from 'gulp';
import concat     from 'gulp-concat';
import uglify     from 'gulp-uglify';
import sourcemaps from 'gulp-sourcemaps';

gulp.task('libs:core',function(){
  return gulp.src([
    './lib/require.js',
    '!./lib/angular*.js',
    '!./lib/jquery*.js',
    './lib/*.js'])
  .pipe(sourcemaps.init())
  .pipe(concat('require.all.js'))
  .pipe(uglify({mangle:false}))
  .pipe(sourcemaps.write('map'))
  .pipe(gulp.dest('./demo/js/'))

});

gulp.task('libs:angular',function(){

  return gulp.src([
    './lib/angular.js',
    './lib/angular-*.js'])
  .pipe(sourcemaps.init())
  .pipe(concat('angular.all.js'))
  .pipe(uglify({mangle:false}))
  .pipe(sourcemaps.write('map'))
  .pipe(gulp.dest('./demo/js/'))

});


gulp.task('libs:jquery',function(){
  return gulp.src([
    './lib/jquery.js',
    './lib/angular.*.js'])
  .pipe(sourcemaps.init())
  .pipe(concat('jquery.all.js'))
  .pipe(uglify({mangle:false}))
  .pipe(sourcemaps.write('map'))
  .pipe(gulp.dest('./demo/js/'))

});

gulp.task('libs',['libs:core','libs:angular','libs:jquery'])