import gulp     from "gulp";
import gulpIf   from "gulp-if";
import uglify   from "gulp-uglify";
import replace  from "gulp-replace";
import TaskEnvConfig from "../config/task.config.js";



gulp.task('fk:js',['fk:js:pro']);

gulp.task('fk:js:dev',function(){
  return fkTask(TaskEnvConfig,'dev');
});
gulp.task('fk:js:test',['fk:js:dev'],function(){
  return fkTask(TaskEnvConfig,'test');
});
gulp.task('fk:js:uat',['fk:js:test'],function(){
  return fkTask(TaskEnvConfig,'uat');
});

gulp.task('fk:js:pro',['fk:js:uat'],function(){
  return fkTask(TaskEnvConfig,'pro');
});

function fkTask(globalConfigs,env){
  var config = globalConfigs[env];
  return gulp.src(globalConfigs.fk.src)
  .pipe(gulpIf(env != 'dev',uglify({
    mangle:false
  })))
  .pipe(gulp.dest(config.dest+'/'+globalConfigs.version+'/static/app/'))
}