import gulp     from "gulp";
import gulpIf   from "gulp-if";
import uglify   from "gulp-uglify";
import replace  from "gulp-replace";
import TaskEnvConfig from "../config/task.config.js";


gulp.task('libs:js',['libs:js:pro']);

// dev环境 libs打包
gulp.task('libs:js:dev','第三方脚本处理',function(){
  return jsLibTask(TaskEnvConfig,'dev');
});

gulp.task('libs:js:test',['libs:js:dev'],function(){
  return jsLibTask(TaskEnvConfig,'test');
});
gulp.task('libs:js:uat',['libs:js:test'],function(){
  return jsLibTask(TaskEnvConfig,'uat');
});
gulp.task('libs:js:pro',['libs:js:uat'],function(){
  return jsLibTask(TaskEnvConfig,'pro');
});


function jsLibTask (globalConfigs,env) {
  var config = globalConfigs[env];
  return gulp.src(globalConfigs.jslibs.src)
  .pipe(gulpIf(env != 'dev',uglify({
    mangle:false
  })))
  .pipe(replace('${jsVersion}',globalConfigs.jsVersion))
  .pipe(gulp.dest(config.dest+'/'+globalConfigs.version+'/bower_components'))
}
