/**
 * Created by huangzx on 2015/6/8.
 */
define('framework/alert/GillionAlertModule', [
    'angular',
    'jquery',
    'css!../../../css/alert.css'
], function (angular, $) {
    return angular.module('GillionAlertModule', [])
        .factory('GillionAlert', function(){
            var $mask,
                dlgCache = {},
                htmlTemplate = {
                    mask:      '<div class="alert-mask"></div>',
                    dialog:    '<div class="alert-dialog-container">' +
                                '<div class="alert-dialog-header">' +
                                '<span class="alert-dialog-title">{0}</span>' +
                                '<button class="alert-close alert-dialog-close">×</button>' +
                                '</div>'+
                                '<div class="alert-dialog-body">{1}</div>' +
                                '<div class="alert-dialog-footer"></div>' +
                                '</div>',
                    alert:      '<div class="alert-alert-container">' +
                                '<div class="alert-alert-body">' +
                                '<span class="alert-alert-icon">{0}</span>' +
                                '<span class="alert-alert-msg">{1}</span>' +
                                '<button class="alert-close">×</button></div>' +
                                '<div class="alert-alert-footer">' +
                                '<button class="alert-close">确定</button>' +
                                '</div>' +
                                '</div>',
                    confirm:   '<div class="alert-confirm-container">' +
                                '<div class="alert-confirm-header">' +
                                '<span class="alert-confirm-title">{0}</span>' +
                                '<button class="alert-close alert-confirm-close">×</button>' +
                                '</div>' +
                                '<div class="alert-confirm-body">{1}</div>' +
                                '<div class="alert-confirm-footer">' +
                                '<button class="yes">是</button><button class="no">否</button>' +
                                '</div>' +
                                '</div>',
                    progress:  '<div class="alert-progress-container">' +
                                '<div class="alert-progress-header">' +
                                '<span class="alert-progress-title">{0}</span>' +
                                '<button class="alert-close alert-progress-close">×</button>' +
                                '</div>' +
                                '<div class="alert-progress-body">{1}</div>' +
                                '</div>',
                    button:    '<button class="{0}">{1}</button>'
                },
                initTemplate = {
                    dialog: function(opt){
                        var t = $(format(htmlTemplate[opt.type], opt.title, opt.msg));
                        $.each(opt.buttons, function(i, button) {
                            t.find('.alert-dialog-footer').append(
                                format(htmlTemplate['button'], button.cls, button.text)
                            );
                            $.isFunction(button.handler) &&
                            t.on('click', '.'+button.cls, function(){
                                button.handler.call(window, dlgCache[opt.tempId]);
                            });
                        });
                        return t;
                    },
                    alert: function(opt) {
                        var t = $(format(htmlTemplate[opt.type], opt.icon, opt.msg));
                        return t;
                    },
                    confirm: function(opt) {
                        var t = $(format(htmlTemplate[opt.type], opt.title, opt.msg));
                        t.find('.alert-confirm-footer').on('click', 'button.yes', function() {
                            if ($.isFunction(opt.fn)) opt.fn.call(window, dlgCache[opt.tempId], true);
                            else dlgCache[opt.tempId].close();
                        }).on('click', 'button.no', function() {
                            if ($.isFunction(opt.fn)) opt.fn.call(window, dlgCache[opt.tempId], false);
                            else dlgCache[opt.tempId].close();
                        });
                        return t;
                    },
                    progress: function(opt) {
                        var t = $(format(htmlTemplate[opt.type], opt.title, opt.msg));
                        return t;
                    }
                };

            /**
             * Format a message with placeholder.
             * Examples:
             * format("X{0}Y{1}Z{2}") : XYZ
             * format("X{0}Y{1}Z{2}", '1') : X1YZ
             * format("X{0}Y{1}Z{2}", '1', '2') : X1Y2Z
             * format("X{0}Y{1}Z{2}", '1', '2', '3') : X1Y2Z3
             * format("X{0}Y{1}Z{2}", '1', '2', '3', '4') : X1Y2Z3
             * ------------------------------------
             * format() : null
             * format("X{0}Y{1}Z{2}", null) : XYZ
             * format(null, '1') : null
             * ------------------------------------
             * format("{0{0}1{1}2{2}}") : {012}
             * format("{0{0}1{1}2{2}}", 'x') : {0x12}
             * format("{0{0}1{1}2{2}}", 'x', 'y') : {0x1y2}
             * format("{0{0}1{1}2{2}}", 'x', 'y', 'z') : {0x1y2z}
             */
            function format( message ) {
                if (!message) return null;
                var ss = message.split(/\{\d+?\}/);
                for ( var i = 0; i < ss.length; i++ ) {
                    if (!arguments[i + 1]) break;
                    ss[i] += arguments[i + 1];
                }
                return ss.join("");
            };
            //居中显示
            function center($dlg){
                $dlg.css({
                    left: ($(window).width() - $dlg.outerWidth())/2,
                    top: ($(window).height() - $dlg.outerHeight())/2
                }).show();
            };

            return {
                /**
                 * 遮罩
                 */
                mask: function() {
                    if (!$mask) {
                        $mask = $(htmlTemplate['mask']);
                        $(document.body).append($mask);
                    }
                    $mask.show();
                },
                /**
                 * 隐藏遮罩
                 */
                hideMask: function() {
                    $mask && $mask.hide();
                },
                /**
                 * 窗口显示通用方法
                 * @param options 自定义配置项
                 *  [options.title='标题'] {String} 标题
                 *  [options.msg='这里是内容'] {String} 内容
                 *  [options.type='dialog'] {String} 弹窗类型，
                 *    取值为：dialog:自定义弹框 alert:信息提示框 confirm:确认取消框  progress:进行中
                 *  [options.modal=false] {Boolean} 模态
                 *  [options.width=300] {Number} 宽带
                 *  [options.height=200] {Number} 高度
                 *  [options.buttons=[{
                                text:'确定',
                                cls : 'alert-confirm',
                                handler : function (dlg) {
                                    dlg.close();
                                }
                            },{
                                text:'取消',
                                cls : 'alert-close'
                            }]] {Array} 底部按钮组，只对type=dialog有效
                            按钮配置 [handler] {function (dlg){}} 回调函数，
                            参数dlg {jQuery(HTMLDivElement)}提供close关闭弹窗方法
                 */
                show: function(options){
                    var self = this,
                        tempId = 'dlg_'+ new Date().getTime(),
                        opt = {
                            tempId:tempId,
                            title: '标题',
                            msg: '这里是内容',
                            type: 'dialog',
                            modal: false,
                            width:300,
                            height:200,
                            buttons: [{
                                text:'确定',
                                cls : 'alert-confirm',
                                handler : function (dlg) {
                                    dlg.close();
                                }
                            },{
                                text:'取消',
                                cls : 'alert-close'
                            }]
                        };
                    $.extend(opt, options);
                    if(opt.modal) self.mask();
                    var $dlg = initTemplate[opt.type].call(window, opt);
                    dlgCache[tempId] = $dlg;
                    $(document.body).append($dlg);
                    $dlg.css({
                        width: opt.width,
                        height: opt.height
                    });
                    center($dlg); //居中显示
                    $(window).resize(function(){center($dlg);});//窗体改变
                    //关闭弹框
                    $dlg.close = function() {
                        $dlg.remove();
                        self.hideMask();
                        dlgCache[tempId] = null;
                    };
                    $dlg.on('click', '.alert-close',function() {
                        $dlg.close();
                    });
                },
                /**
                 * 信息提示
                 * @param [msg] {String} 信息
                 * @param [icon] {String} 信息类型
                 * @param [modal] {Boolean} 模态
                 */
                alert: function(msg, icon, modal){
                    this.show({
                        type: 'alert',
                        msg: msg || '这只是简单的成功信息',
                        icon: icon || 'suc',
                        modal: !!modal,
                        height : 60
                    });
                },
                /**
                 * 确认对话框
                 * @param [title] {String} 标题
                 * @param [msg] {String} 信息
                 * @param [fn] {function(dlg, r){}} 回调函数，参数dlg {jQuery(HTMLDivElement)}提供close关闭弹窗方法，
                 *                  参数 r {boolean} 对应是否选项
                 * @param [modal] {Boolean} 模态
                 */
                confirm: function(title, msg, fn, modal) {
                    this.show({
                        type: 'confirm',
                        title: title || '提示信息',
                        msg: msg || '是否继续操作，请确认',
                        fn : fn,
                        modal: !!modal,
                        height: 60
                    });
                },
                /**
                 * 进度条
                 * @param [title] {String} 标题
                 * @param [msg] {String} 消息
                 * @param [fn] {function(dlg){}} 回调方法,参数dlg {jQuery(HTMLDivElement)}提供close关闭弹窗方法
                 * @param [modal] [Boolean] 模态
                 */
                progress: function(title, msg, fn, modal) {
                    var tempId = 'dlg_'+ new Date().getTime();
                    this.show({
                        tempId:tempId,
                        type: 'progress',
                        title: title || '正在提交',
                        msg: msg || '&nbsp;',
                        modal: !!modal,
                        height: 60
                    });
                    if ($.isFunction(fn)) {
                        fn.call(window, dlgCache[tempId]);
                    } else {//默认3秒后关闭
                        setTimeout(dlgCache[tempId].close, 3000);
                    }
                }
            };
        });
});