// Generated by CoffeeScript 1.9.3
(function () {
    define(["angular"], function (angular) {

        /*生成请求参数 */
        var DataSource, PageDataSource, combinationPageParams, combinationParams, doRequestNotPageData, doRequestPageData, generatorParams, initEnv;
        generatorParams = function () {
            var me, params, requestParams;
            me = this;
            requestParams = {};
            params = this.params;
            requestParams = {};

            /*设置分页以及排序参数 */
            if (me instanceof PageDataSource) {
                this.$scope.pageSizeSetter(requestParams, this.pageSize);
                this.$scope.currentPageSetter(requestParams, this.currentPage);
                this.$scope.sortNameSetter(requestParams, this.sortName);
                this.$scope.sortDirectionSetter(requestParams, this.sortDirection);
            }

            /*加入请求参数 */
            if (angular.isFunction(this.params)) {
                angular.extend(requestParams, this.params.call());
            } else {
                angular.extend(requestParams, this.params);
            }
            return requestParams;
        };

        /*组合分页参数 */
        combinationPageParams = function (page, params) {
            var me, requestParams;
            me = this;
            if (!!params) {
                me.params = params;
            }
            if (angular.isDefined(page)) {
                me.currentPage = !angular.isNumber(page || page < 1) ? 1 : page;
            }

            /*2.组合分页参数 */
            requestParams = generatorParams.call(me);
            return requestParams;
        };

        /*组合参数 */
        combinationParams = function (params) {
            var me, requestParams;
            me = this;
            if (!!params) {
                this.params = params;
            }

            /*2.组合参数 */
            requestParams = generatorParams.call(me);
            return requestParams;
        };

        /*请求分页数据 */
        doRequestPageData = function (requestParams, callback) {
            var caculateTotalPage, handleResult, me, requestArg, url;
            me = this;
            requestArg = [me.url];
            url = me.url;
            requestArg.push({
                "params": requestParams,
                "failHandler": me.$scope.failHandler
            });
            caculateTotalPage = function () {
                if (me.totalRecord % me.pageSize > 0) {
                    me.totalPage = parseInt(me.totalRecord / me.pageSize, 10) + 1;
                } else {
                    me.totalPage = parseInt(me.totalRecord / me.pageSize, 10);
                }
            };
            handleResult = function (result) {
                me.totalRecord = me.$scope.totalRecordGetter(result);

                /*计算总页数 */
                caculateTotalPage();
                me.records = me.$scope.recordsGetter(result);
                me.moreAttrs = me.$scope.moreAttrsGetter(result);
                if (angular.isFunction(callback)) {
                    callback.call(me, me);
                }

                /*触发sourceManager的promise */
                if (angular.isUndefined(me.$dataSourceManager.defereds[me.sourceName])) {
                    me.$dataSourceManager.getDataSource(me.sourceName);
                }
                me.$dataSourceManager.defereds[me.sourceName].resolve();
                return me.$dataSourceManager.defereds[me.sourceName] = me.$q.defer();
            };
            if(angular.isDefined(this.$scope.beforeLoad)){
                this.$scope.beforeLoad.call(this,this);
            }
            me.$http.get.apply(window, requestArg).success(function (result) {
                if (me.$scope.$root.$$phase) {
                    handleResult(result);
                } else {
                    me.$scope.$apply(function () {
                        return handleResult(result);
                    });
                }
                me.$dataSourceManager.$rootScope.$broadcast(me.sourceName, me);
                if(angular.isDefined(me.$scope.afterLoad)){
                    me.$scope.afterLoad.call(me,me);
                }
            });
        };
        doRequestNotPageData = function (requestParams, callback) {
            var me, requestArg, url;
            me = this;
            requestArg = [me.url];
            url = me.url;
            requestArg.push({
                "params": requestParams,
                "failHandler": me.$scope.failHandler
            });
            if(angular.isDefined(this.$scope.beforeLoad)){
                this.$scope.beforeLoad.call(this,this);
            }
            this.$http.get.apply(window, requestArg).success(function (result) {
                if (angular.isDefined(me.$scope.recordsProp)) {
                    me.records = me.$scope.recordsGetter(result);
                } else {
                    me.records = result;
                }
                if (angular.isFunction(callback)) {
                    callback.call(me, me);
                }

                /*触发sourceManager的promise */
                if (angular.isUndefined(me.$dataSourceManager.defereds[me.sourceName])) {
                    me.$dataSourceManager.getDataSource(me.sourceName);
                }
                me.$dataSourceManager.defereds[me.sourceName].resolve();
                me.$dataSourceManager.defereds[me.sourceName] = me.$q.defer();
                me.$dataSourceManager.$rootScope.$broadcast(me.sourceName, me);
                if(angular.isDefined(me.$scope.afterLoad)){
                    me.$scope.afterLoad.call(me,me);
                }
            });
        };

        /*简单后台数据源 */
        DataSource = (function () {
            function DataSource($scope1, $http1, $timeout1, $q1, $dataSourceManager1) {
                this.$scope = $scope1;
                this.$http = $http1;
                this.$timeout = $timeout1;
                this.$q = $q1;
                this.$dataSourceManager = $dataSourceManager1;
                this.sourceName = this.$scope.sourceName;
                this.url = this.$scope.url;
                this.records = void 0;
                this.params = this.$scope.params;
                this.reqTimer = void 0;
                if (this.$scope.allowAutoLoad) {
                    this._initSourceListener();
                }
            }


            /*请求数据 */

            DataSource.prototype.doRequestData = function (params, callback, forceRequest) {
                var me, requestParams;
                me = this;
                if (forceRequest) {
                    requestParams = combinationParams.call(me, params);
                    doRequestNotPageData.call(me, requestParams, callback);
                    return;
                }
                if (angular.isUndefined(this.reqTimer)) {
                    requestParams = combinationParams.call(me, params);
                    this.reqTimer = this.$timeout(function () {
                        doRequestNotPageData.call(me, requestParams, callback);
                    });
                } else {
                    this.$timeout.cancel(this.reqTimer);
                    requestParams = combinationParams.call(me, params);
                    this.reqTimer = this.$timeout(function () {
                        doRequestNotPageData.call(me, requestParams, callback);
                    });
                }
            };

            DataSource.prototype._initSourceListener = function () {
                var me;
                me = this;
                this.$scope.$watch("dataSource.params", function () {
                    return me.doRequestData();
                }, this.$scope.allowParamDepthListener);
            };

            return DataSource;

        })();

        /*分页数据源 */
        PageDataSource = (function () {
            function PageDataSource($scope1, $http1, $timeout1, $q1, $dataSourceManager1) {
                this.$scope = $scope1;
                this.$http = $http1;
                this.$timeout = $timeout1;
                this.$q = $q1;
                this.$dataSourceManager = $dataSourceManager1;
                this.sourceName = this.$scope.sourceName;
                this.url = this.$scope.url;
                this.records = void 0;
                this.totalRecord = 0;
                this.totalPage = 0;
                this.pageSize = parseInt(this.$scope.pageSize) || 10;
                this.currentPage = parseInt(this.$scope.currentPage) || 1;
                this.params = this.$scope.params;
                this.moreAttrs = void 0;
                this.reqTimer = void 0;
                this.sortName = this.$scope.sortName;
                this.sortDirection = this.$scope.sortDirection;
                if (this.$scope.allowAutoLoad) {
                    this._initSourceListener();
                }
            }


            /*请求分页数据 */

            PageDataSource.prototype.doRequestData = function (page, params, callback, forceRequest) {
                var me, requestParams;
                me = this;
                if (forceRequest) {
                    requestParams = combinationPageParams.call(me, page, params);
                    doRequestPageData.call(me, requestParams, callback);
                    return;
                }
                if (angular.isUndefined(this.reqTimer)) {
                    requestParams = combinationPageParams.call(me, page, params);
                    this.reqTimer = this.$timeout(function () {
                        doRequestPageData.call(me, requestParams, callback);
                    });
                } else {
                    this.$timeout.cancel(this.reqTimer);
                    requestParams = combinationPageParams.call(me, page, params);
                    this.reqTimer = this.$timeout(function () {
                        doRequestPageData.call(me, requestParams, callback);
                    });
                }
            };


            /*初始化属性监听 */

            PageDataSource.prototype._initSourceListener = function () {
                var me;
                me = this;

                /*监听分页大小 */
                me.$scope.$watch("dataSource.pageSize", function () {
                    me.currentPage = 1;
                    return me.doRequestData();
                });

                /*监听当前分页 */
                me.$scope.$watch("dataSource.currentPage", function (newVal, oldVal) {
                    newVal = parseInt(newVal);
                    if (angular.isNumber(newVal)) {
                        if (newVal >= 1) {
                            if (newVal <= me.totalPage || (newVal === 1 && me.totalPage === 0)) {
                                return me.doRequestData();
                            } else {
                                me.currentPage = oldVal;
                                throw new Error("当前请求分页大于总页数");
                            }
                        } else {
                            me.currentPage = oldVal;
                            throw new Error("当前页码必须大于1");
                        }
                    } else {
                        me.currentPage = oldVal;
                        throw new Error("当前页码必须为数字");
                    }
                });

                /*监听当前请求参数 */
                me.$scope.$watch("dataSource.params", function () {
                    me.currentPage = 1;
                    return me.doRequestData();
                }, this.$scope.allowParamDepthListener);

                /*监听当前排序字段名称 */
                me.$scope.$watch("dataSource.sortName", function () {
                    me.currentPage = 1;
                    return me.doRequestData();
                });

                /*监听当前排序方向 */
                me.$scope.$watch("dataSource.sortDirection", function () {
                    me.currentPage = 1;
                    return me.doRequestData();
                });
            };

            return PageDataSource;

        })();

        /*初始化属性环境 */
        initEnv = function ($scope, $attr, $parse, $http, $timeout, $q, $dataSourceManager) {
            var dataSource;
            $scope.allowAutoLoad = $scope.$eval($attr.allowAutoLoad) || false;
            $scope.allowParamDepthListener = $scope.$eval($scope.allowParamDepthListener) || false;
            $scope.page = $scope.$eval($scope.page) || false;
            $scope.failHandler = $scope.failHandler();
            $scope.beforeLoad = $scope.beforeLoad();
            $scope.afterLoad = $scope.afterLoad();
            /*初始化属性 */
            if ($scope.page) {
                $scope.totalRecordProp = $scope.totalRecordProp || "totalRecord";
                $scope.recordsProp = $scope.recordsProp || "records";
                $scope.pageSizeParam = $scope.pageSizeParam || "pageSize";
                $scope.currentPageParam = $scope.currentPageParam || "currentPage";
                $scope.sortNameParam = $scope.sortNameParam || "sortName";
                $scope.sortDirectionParam = $scope.sortDirectionParam || "sortDirection";
                $scope.moreAttrsProp = $scope.moreAttrsProp || "moreAttrs";

                /*初始化Getter */
                $scope.totalRecordGetter = $parse($scope.totalRecordProp);
                $scope.recordsGetter = $parse($scope.recordsProp);
                $scope.pageSizeGetter = $parse($scope.pageSizeParam);
                $scope.currentPageGetter = $parse($scope.currentPageParam);
                $scope.sortNameGetter = $parse($scope.sortNameParam);
                $scope.sortDirectionGetter = $parse($scope.sortDirectionParam);
                $scope.moreAttrsGetter = $parse($scope.moreAttrsProp);

                /*初始化Setter */
                $scope.pageSizeSetter = $scope.pageSizeGetter.assign;
                $scope.currentPageSetter = $scope.currentPageGetter.assign;
                $scope.sortNameSetter = $scope.sortNameGetter.assign;
                $scope.sortDirectionSetter = $scope.sortDirectionGetter.assign;
                $scope.moreAttrsSetter = $scope.moreAttrsGetter.assign;

                /*初始化DataSource */
                dataSource = new PageDataSource($scope, $http, $timeout, $q, $dataSourceManager);
            } else {
                if (angular.isDefined($scope.recordsProp)) {
                    $scope.recordsGetter = $parse($scope.recordsProp);
                }
                dataSource = new DataSource($scope, $http, $timeout, $q, $dataSourceManager);
            }
            $scope.dataSource = dataSource;
        };
        return function ($http, $parse, $timeout, $q, $dataSourceManager) {
            return {
                restrict: "E",
                scope: {
                    url: "@",
                    params: "=",
                    sourceName: "@",
                    page: "@",
                    pageSize: "@",
                    currentPage: "@",
                    sortName: "@",
                    sortDirection: "@",

                    /*从结果中取值 */
                    totalRecordProp: "@",
                    recordsProp: "@",
                    moreAttrsProp: "@",

                    /*用于获取参数 */
                    pageSizeParam: "@",
                    currentPageParam: "@",
                    sortNameParam: "@",
                    sortDirectionParam: "@",

                    /*是否进行自动加载 */
                    /*allowAutoLoad: "@",*/

                    failHandler: "&",

                    /*加载前和加载后事件*/
                    beforeLoad: "&",
                    afterLoad: "&",

                    /*请求参数是否进行深度监听 */
                    allowParamDepthListener: "@"
                },
                link: function ($scope, $element, $attr) {

                    /*初始化数据源环境参数 */
                    initEnv($scope, $attr, $parse, $http, $timeout, $q, $dataSourceManager);
                    $scope.api = $scope.dataSource;

                    /*在Manager中注册当前数据源 */
                    $dataSourceManager.registerDataSource($scope.sourceName, $scope.dataSource);

                    /*触发sourceManager的promise */
                    $timeout(function () {
                        if (angular.isUndefined($dataSourceManager.defereds[$scope.sourceName])) {
                            $dataSourceManager.getDataSource($scope.sourceName);
                        }
                        $dataSourceManager.defereds[$scope.sourceName].resolve();
                        return $dataSourceManager.defereds[$scope.sourceName] = $q.defer();
                    });
                }
            };
        };
    });

}).call(this);
