define('framework/datatree/GillionDataTreeDirectiveConstructor',["angular", 'underscore'], function (angular,_) {
    var DataTree,initDataTree;
    DataTree = (function(){
        function DataTree(name,$scope){
            this.name = name;
            this.$scope = $scope;
        }
        //根据id获取结点
        DataTree.prototype.searchNodeById = function(idProp){
            var ele;
            ele = searchNodeByTd(this.$scope.treeData,idProp);
            if(ele){
                 return ele.originData;
            }
        }
        //根据显示值获取结点
        DataTree.prototype.searchNodeByValue = function(value){
            var  result=[],nodes,el;
            nodes = findNodeByValue(this.$scope.treeData,value);
            if(nodes && nodes.length>0){
                for(el in nodes){
                    result.push(nodes[el].originData);
                }
            }
            return result;
        }
        //查询子结点
        DataTree.prototype.searchChildren = function(idProp){
            var ele,children=[];
            ele = searchNodeByTd(this.$scope.treeData,idProp);
            if(ele && ele.children && ele.children.length>0){
                for(item in ele.children){
                    children.push(ele.children[item].originData);
                }
            }
            return children;
        }
        //设置隐藏或显示
        DataTree.prototype.displayNode = function(idProp,show){
            var ele,el;
            if(angular.isUndefined(show)){
                show = true;
            }
            if(angular.isArray(idProp) && idProp.length>0){
                for(ele in idProp){
                    el = searchNodeByTd(this.$scope.treeData,idProp[ele]);
                    el.display = show;
                }
            }else{
                el = searchNodeByTd(this.$scope.treeData,idProp);
                el.display = show;
            }
        }
        //设置编辑状态
        DataTree.prototype.editable = function(idProp,editable){
            var ele,el;
            if(angular.isUndefined(editable)){
                editable = true;
            }
            if(angular.isArray(idProp) && idProp.length>0){
                for(ele in idProp){
                    el = searchNodeByTd(this.$scope.treeData,idProp[ele]);
                    el.editable = editable;
                }
            }else{
                el = searchNodeByTd(this.$scope.treeData,idProp);
                el.editable = editable;
            }
        }

        //展开结点
        DataTree.prototype.expandNode = function(idProp,expand,isChildren){
            var paramArg,scope=this.$scope,item,config=scope.config;
            expand = expand!==false;
            item = searchNodeByTd(scope.treeData,idProp);
            if(angular.isUndefined(scope.disabled) && item.disabled===false){
                paramArg = {
                    record:item.originData
                }
                if(item.expanded===false && expand===true){
                    if(!(scope.beforeExpand(paramArg)===false)){
                        if(scope.async==="true"){
                            scope.source.params[config.idProp] =item.idProp;
                            if(isChildren===true){
                                scope.source.params.child = "true";
                            }
                            scope.source.doRequestData(scope.source.params,function(_dataSource){
                                var records,children;
                                records = angular.copy(_dataSource.records);
                                if(item){
                                    if(!records || records.length===0){
                                        item.type="leaf";
                                    }else{
                                        children = createChildren(item,records,config,isChildren);
                                        //children = transcateChildren(records,config);
                                        angular.extend(item.children,children);
                                        if(item.checked){
                                            //angular.forEach(children,function(child){
                                            //    if(child.showBox && !child.checked && child.readonly===false && child.disabled === false){
                                            //        child.checked = true;
                                            //        if(contains(scope._chooseItems,child)===false){
                                            //            scope._chooseItems.push(child);
                                            //        }
                                            //    }
                                            //});
                                            selectChild(item,scope);
                                        }
                                        //if(isChildren===true){
                                        //    for(var i=0;i<children.length;i++){
                                        //        arguments.callee(children[i].idProp,expand,isChildren);
                                        //    }
                                        //}
                                    }
                                }
                                item.expanded=!item.expanded;
                                scope.onExpand(paramArg);
                            },true);
                        }
                    }
                }else if(item.expanded===true &&  expand===false){
                    item.expanded=!item.expanded;
                }
            }
        }

        //设置只读属性
        DataTree.prototype.readonly = function(idProp,readonly){
            var ele,el;
            if(angular.isUndefined(readonly)){
                readonly = true;
            }
            if(angular.isArray(idProp) && idProp.length>0){
                for(ele in idProp){
                    el = searchNodeByTd(this.$scope.treeData,idProp[ele]);
                    el.readonly = readonly;
                }
            }else{
                el = searchNodeByTd(this.$scope.treeData,idProp);
                el.readonly = readonly;
            }
        }
        //设置disable属性
        DataTree.prototype.disabled = function(idProp,disabled){
            var ele,el;
            if(angular.isUndefined(disabled)){
                disabled = true;
            }
            if(angular.isArray(idProp) && idProp.length>0){
                for(ele in idProp){
                    el = searchNodeByTd(this.$scope.treeData,idProp[ele]);
                    el.disabled = disabled;
                }
            }else{
                el = searchNodeByTd(this.$scope.treeData,idProp);
                el.disabled = disabled;
            }
        }

        //设置结点的勾选状态
        DataTree.prototype.check = function(idProp,checked){
            var ele,el;
            if(angular.isUndefined(checked)){
                checked = true;
            }
            if(angular.isArray(idProp) && idProp.length>0){
                for(ele in idProp){
                    el = searchNodeByTd(this.$scope.treeData,idProp[ele]);
                    if(!el) continue;
                    if(checked){
                        doCheck(el,this.$scope);
                    }else{
                        el.checked = false;
                        removeItem(this.$scope._chooseItems,el);
                    }
                }
            }else{
                el = searchNodeByTd(this.$scope.treeData,idProp);
                if(!el) return;
                if(checked){
                    doCheck(el,this.$scope);
                }else{
                    el.checked = false;
                    removeItem(this.$scope._chooseItems,el);
                }
            }
        }
        return DataTree;
    })();


    function removeItem(source,item){
        var i,el,len = source.length;
        for(i=0;i<len;i++){
            if(source[i] === item){
                source.splice(i,1);
                break;
            }
        }
    }

    function remove(source,item){
        for(var i=0;i<source.length;i++){
            if(source[i].idProp === item.idProp){
                source.splice(i,1);
                break;
            }
        }
    }

    function contains(source,item){
        var flag =false;
        for(var i=0;i<source.length;i++){
            if(source[i].idProp === item.idProp){
                flag = true;
                break;
            }
        }
        return flag;
    }

    function doCheck(item,scope){
        if(item.showBox && angular.isUndefined(scope.disabled) && item.readonly===false && item.disabled===false && item.checked ===false){
            item.checked = true;
            if(contains( scope._chooseItems,item,scope.config)===false){
                scope._chooseItems.push(item);
            }
        }
    }

    //选中结点的所有子孙
    function selectChild(item,scope){
        var i,len,el,children;
        children = item.children || [];
        for(i=0,len=children.length; i<len; i++){
            el = children[i];
            //可以选择，并且还没有被选中
            if(el.showBox && !el.checked && el.readonly===false && el.disabled === false){
                el.checked = true;
                if(contains(scope._chooseItems,el,scope.config)===false){
                    scope._chooseItems.push(el);
                }
            }
            if(el.children && el.children.length>0){
                arguments.callee(el,scope);
            }
        }
    };

    initDataTree = function(name,$scope){
        var dataTree;
        dataTree = new DataTree(name,$scope);
        $scope.dataTree = dataTree;
    }

    //根据id查找结点
    function searchNodeByTd(treeData,id){
        var i,len,el,result,childRes;
        for(i=0, len = treeData.length; i<len; i++){
            el = treeData[i];
            if(el.idProp === id){
                result=el;
                break;
            }
            if(el.children && el.children.length>0){
                childRes = arguments.callee(el.children,id);
            }
            if(childRes){
                result = childRes;
                break;
            }
        }
        return result;
    }

    //根据值查找结点
    function findNodeByValue(treeData,value){
        var result=[],childItems=[],
            i,len,el;
        for(i=0, len=treeData.length; i<len; i++){
            el = treeData[i];
            if(el.valueProp===value){
                result.push(el);
            }
            if(el.children && el.children.length>0){
                childItems = arguments.callee(el.children,value);
            }
            if(childItems && childItems.length>0){
                result = result.concat(childItems);
                childItems = [] ;
            }
        }
        return result;
    }

    
    //生成结点
    function createNode(item,config){
        var  prop = config.idProp,
            parentProp = config.parentProp,
            hasChildProp = config.hasChildProp,
            valueProp = config.valueProp,
            displayExpress = config.displayExpress,
            showBox = config.showBox,
            isExpandAll = config.isExpandAll,
            async = config.async,
            itemClass = config.itemClass,
            itemRootScope = config.itemRootScope,
            displayItem = config.displayItem,
            editable = config.editable,
            readonlyItem = config.readonlyItem,
            disabledItem = config.disabledItem,
            ele,el,show,display,editable1,readonly,disabled;
        el = item;
        ele = {};
        ele.idProp = el[prop];
        ele.parentProp = el[parentProp];
        ele.valueProp= el[valueProp];
        ele.displayExpress = el[displayExpress];
        ele.showBox = true;
        if(angular.isFunction(showBox())){
            ele.showBox = (showBox()(el)===true);
        }else{
            show = showBox(el);
            if(show!==undefined){
                ele.showBox = (show===true);
            }
        }
        ele.originData=el;
        ele.checked=false;
        ele.children=[];
        ele.display = true;
        if(angular.isFunction(displayItem())){
            ele.display = (displayItem()(el)===true);
        }else{
            display = displayItem(el);
            if(display!==undefined){
                ele.display = (display===true);
            }
        }
        ele.editable = false;
        if(angular.isFunction(editable())){
            ele.editable = (editable()(el)===true);
        }else{
            editable1 = editable(el);
            if(editable1!==undefined){
                ele.editable = (editable1===true);
            }
        }
        ele.readonly = false;
        if(angular.isFunction(readonlyItem())){
            ele.readonly = (readonlyItem()(el)===true);
        }else{
            readonly = readonlyItem(el);
            if(readonly!==undefined){
                ele.readonly = (readonly===true);
            }
        }

        ele.disabled = false;
        if(angular.isFunction(disabledItem())){
            ele.disabled = (disabledItem()(el)===true);
        }else{
            disabled = disabledItem(el);
            if(disabled!==undefined){
                ele.disabled = (disabled===true);
            }
        }
        ele.expanded=false;
        if(async==="true"){
            if(el[hasChildProp]==='true' || el[hasChildProp]===true || !hasChildProp){
                ele.type="branch";
            }else{
                ele.type="leaf";
            }
        }else{
            ele.type="leaf";
            if(isExpandAll==="true"){
                ele.expanded=true;
            }
        }
        ele.itemClass = itemClass;
        ele.itemRootScope = itemRootScope;
        return ele;
    }


    //构建树
    function buildTree(source,config) {
        source = angular.copy(source);
        var prop = config.idProp,
            parentProp = config.parentProp,
            results = [],
            fetchChildrenFn,
            margin, i, len, el,ele;
        fetchChildrenFn = function (element, margin) {
            if (margin.length === 0) return;
            var children = [],
                i, len, el, childrenMargin,ele,show;
            for (i = 0, len = margin.length; i < len; i++) {
                el = margin[i];
                if (el[parentProp] === element.idProp) {
                    ele = {};
                    ele = createNode(el,config);
                    children.push(ele);
                    ele = null;
                }
            }
            childrenMargin = _.difference(margin, children);
            for (i = 0, len = children.length; i < len; i++) {
                el = children[i];
                fetchChildrenFn(el, childrenMargin);
            }
            if (children.length > 0) {
                element.children = children;
                element.type="branch";
            }
        }

        if(!source || source.length===0){
            return results;
        }
        for (i = 0, len = source.length; i < len; i++) {
            el = source[i];
            if (!el[parentProp]) {
                ele = {};
                ele =  createNode(el,config);
                results.push(ele);
                ele = null;
            }
        }
        margin = _.difference(source, results);
        // copy放在下面是为了subtract使用'==='而不是equals， 效率更高
        for (i = 0, len = results.length; i < len; i++) {
            el = results[i];
            fetchChildrenFn(el, margin);
        }
        return results;
    }

    //创建子孙结点
    function createChildren(item,records,config,isChildren){
        var result,itemIdProp, i,len,el,ele,child;
        result = [];
        len = records.length;
        for(i=0;i<len;i++){
            el = records[i];
            if(el[config.parentProp] === item.idProp){
                ele = createNode(el,config);
                if(isChildren){
                    ele.expanded = true;
                }
                result.push(ele);
            }
        }
        if(result.length>0){
            for(i=0;i<result.length;i++){
                child = arguments.callee(result[i],records,config,isChildren);
                result[i].children = child;
            }
        }
        return result;
    }

    //加载子结点
    function transcateChildren(records,config){
        var i,len,result,el,ele;
        result=[];
        for(i=0,len=records.length;i<len;i++){
            el = records[i];
            ele = {};
            ele = createNode(el,config)
            result.push(ele);
        }
        return result;
    }


    return function($compile,Arrays,$dataSourceManager,$templateCache,$dataTreeManager,$timeout) {
        var recursiveTemplate, template;
        template =  '<div class="tree">'+
        '   <div ng-disabled="disabled" class="tree-head">'+
        '      <ul class="tree-head-selecteds">'+
        '         <li>{{titleExpress===""?"":(titleExpress || "选择：")}}</li>'+
        '         <li ng-disabled="disabled" ng-repeat="item in _chooseItems" ng-click="deleteChooseItem(item)">{{item.displayExpress}}</li>'+
        '      </ul>'+
        '      <button ng-if="showRechoose"  ng-disabled="disabled" class="btn tree-btn-reset"  ng-click="clearChooseItems()">重选</button>'+
        '   </div>'+
        '   <div class="tree-body">'+
        '   <ul ng-include="\'/datatree/template\'"></ul>'+
        '   </div>'+
        '</div>';
        recursiveTemplate = '<li ng-if="(!item.type || item.type===\'branch\') &&  item.expanded && item.display===true" open="true"  ng-repeat-start="item in treeData">'+
        '   <div class="tree-item" ng-if="currentRow===item.originData" ng-click="rowClick($event,item)" selected="selected" ng-disabled="item.disabled">'+
        '      <i class="fi tree-fi-folder" ng-click="expandNode(item)"></i>'+
        '      <i ng-if="!radio && item.checked && item.showBox && allowChooseParent && showCheckBox" class="fi tree-fi-clickbox" selected="selected" ng-click="chooseItem($event,item)"></i>'+
        '      <i ng-if="!radio && !item.checked && item.showBox && allowChooseParent && showCheckBox" class="fi tree-fi-clickbox" ng-click="chooseItem($event,item)"></i>'+
        '      <i ng-if="(!item.showBox || radio)  && showCheckBox" class="fi tree-fi-clickbox && showCheckBox" canchoose="false" ng-click="chooseItem($event,item)"></i>'+
        '      <span ng-dblclick="onDblClick($event,item)" ng-if="item.editable===false" ng-click="rowClick($event,item)"  outer-scope="item.itemRootScope" render-item-class="item.itemClass" render-item-class-locals="{record:item.originData}" >{{item.displayExpress}}</span>'+
        '      <input style="width:50%;" ng-blur="onBlur($event,item)" ng-keypress="onKeyPress($event,item)" ng-if="item.editable===true && item.readonly===false && item.disabled===false" outer-scope="item.itemRootScope" render-item-class="item.itemClass" render-item-class-locals="{record:item.originData}" value="{{item.displayExpress}}"/>'+
        '   </div>'+
        '   <div class="tree-item" ng-if="currentRow!==item.originData" ng-click="rowClick($event,item)" ng-disabled="item.disabled">'+
        '      <i class="fi tree-fi-folder" ng-click="expandNode(item)"></i>'+
        '      <i ng-if="!radio && item.checked && item.showBox && allowChooseParent && showCheckBox" class="fi tree-fi-clickbox" selected="selected" ng-click="chooseItem($event,item)"></i>'+
        '      <i ng-if="!radio && !item.checked && item.showBox && allowChooseParent  && showCheckBox" class="fi tree-fi-clickbox" ng-click="chooseItem($event,item)"></i>'+
        '      <i ng-if="(!item.showBox || radio)  && showCheckBox" class="fi tree-fi-clickbox" canchoose="false" ng-click="chooseItem($event,item)"></i>'+
        '      <span ng-dblclick="onDblClick($event,item)" ng-if="item.editable===false" ng-click="rowClick($event,item)"  outer-scope="item.itemRootScope" render-item-class="item.itemClass" render-item-class-locals="{record:item.originData}" >{{item.displayExpress}}</span>'+
        '      <input style="width:50%;" ng-blur="onBlur($event,item)" ng-keypress="onKeyPress($event,item)"  ng-if="item.editable===true && item.readonly===false && item.disabled===false"   outer-scope="item.itemRootScope" render-item-class="item.itemClass" render-item-class-locals="{record:item.originData}"  value="{{item.displayExpress}}"/>'+
        '   </div>'+
        '   <ul ng-include="\'/datatree/template\'" ng-init="treeData=item.children"></ul>'+
        '</li>'+

        '<li ng-if="(!item.type || item.type===\'branch\') &&  !item.expanded  && item.display===true" >'+
        '   <div class="tree-item" ng-if="currentRow===item.originData" ng-click="rowClick($event,item)" selected="selected" ng-disabled="item.disabled">'+
        '      <i class="fi tree-fi-folder" ng-click="expandNode(item)"></i>'+
        '      <i ng-if="!radio && item.checked && item.showBox && allowChooseParent  && showCheckBox" class="fi tree-fi-clickbox" selected="selected" ng-click="chooseItem($event,item)"></i>'+
        '      <i ng-if="!radio && !item.checked && item.showBox && allowChooseParent  && showCheckBox" class="fi tree-fi-clickbox" ng-click="chooseItem($event,item)"></i>'+
        '      <i ng-if="(!item.showBox || radio || !allowChooseParent) && showCheckBox" class="fi tree-fi-clickbox" canchoose="false" ng-click="chooseItem($event,item)"></i>'+
        '      <span ng-dblclick="onDblClick($event,item)" ng-if="item.editable===false"  ng-click="rowClick($event,item)" outer-scope="item.itemRootScope" render-item-class="item.itemClass" render-item-class-locals="{record:item.originData}" >{{item.displayExpress}}</span>'+
        '      <input style="width:50%;" ng-blur="onBlur($event,item)" ng-keypress="onKeyPress($event,item)" ng-if="item.editable===true && item.readonly===false && item.disabled===false" outer-scope="item.itemRootScope" render-item-class="item.itemClass" render-item-class-locals="{record:item.originData}" value="{{item.displayExpress}}" />'+
        '   </div>'+
        '   <div class="tree-item" ng-if="currentRow!==item.originData" ng-click="rowClick($event,item)"  ng-disabled="item.disabled">'+
        '      <i class="fi tree-fi-folder" ng-click="expandNode(item)"></i>'+
        '      <i ng-if="!radio && item.checked && item.showBox && allowChooseParent  && showCheckBox" class="fi tree-fi-clickbox" selected="selected" ng-click="chooseItem($event,item)"></i>'+
        '      <i ng-if="!radio && !item.checked && item.showBox && allowChooseParent  && showCheckBox" class="fi tree-fi-clickbox" ng-click="chooseItem($event,item)"></i>'+
        '      <i ng-if="(!item.showBox || radio || !allowChooseParent)  && showCheckBox" class="fi tree-fi-clickbox" canchoose="false" ng-click="chooseItem($event,item)"></i>'+
        '      <span ng-dblclick="onDblClick($event,item)" ng-if="item.editable===false" ng-click="rowClick($event,item)" outer-scope="item.itemRootScope" render-item-class="item.itemClass" render-item-class-locals="{record:item.originData}" >{{item.displayExpress}}</span>'+
        '      <input style="width:50%;" ng-blur="onBlur($event,item)" ng-keypress="onKeyPress($event,item)" ng-if="item.editable===true && item.readonly===false && item.disabled===false" outer-scope="item.itemRootScope" render-item-class="item.itemClass" render-item-class-locals="{record:item.originData}" value="{{item.displayExpress}}"/>'+
        '   </div>'+
        '   <ul ng-include="\'/datatree/template\'" ng-init="treeData=item.children"></ul>'+
        '</li>'+

        '<li ng-if="item.type === \'leaf\'  && item.display===true" ng-repeat-end>'+
        '    <div class="tree-item"  leaf="true" ng-if="currentRow===item.originData" selected="selected">'+
        '      <i class="fi tree-fi-folder"></i>'+
        '      <i ng-if="radio && item.checked && item.showBox && showCheckBox" class="fi tree-fi-clickbox" mode="radio" selected="selected" ng-click="chooseItem($event,item)"></i>'+
        '      <i ng-if="radio && !item.checked && item.showBox  && showCheckBox" class="fi tree-fi-clickbox"  mode="radio" ng-click="chooseItem($event,item)"></i>'+
        '      <i ng-if="!radio && item.checked && item.showBox  && showCheckBox" class="fi tree-fi-clickbox" selected="selected" ng-click="chooseItem($event,item)"></i>'+
        '      <i ng-if="!radio && !item.checked && item.showBox  && showCheckBox" class="fi tree-fi-clickbox" ng-click="chooseItem($event,item)"></i>'+
        '      <i ng-if="!item.showBox  && showCheckBox" class="fi tree-fi-clickbox" canchoose="false"></i>'+
        '      <span ng-dblclick="onDblClick($event,item)" ng-if="item.editable===false" ng-click="rowClick($event,item)"  outer-scope="item.itemRootScope" render-item-class="item.itemClass" render-item-class-locals="{record:item.originData}" >{{item.displayExpress}}</span>'+
        '      <input style="width:50%;"  ng-blur="onBlur($event,item)" ng-keypress="onKeyPress($event,item)" ng-if="item.editable===true && item.readonly===false && item.disabled===false"   outer-scope="item.itemRootScope" render-item-class="item.itemClass" render-item-class-locals="{record:item.originData}" value="{{item.displayExpress}}"/>'+
        '    </div>'+
        '    <div class="tree-item"  leaf="true" ng-if="currentRow!==item.originData">'+
        '      <i class="fi tree-fi-folder"></i>'+
        '      <i ng-if="radio && item.checked && item.showBox  && showCheckBox" class="fi tree-fi-clickbox" mode="radio" selected="selected" ng-click="chooseItem($event,item)"></i>'+
        '      <i ng-if="radio && !item.checked && item.showBox  && showCheckBox" class="fi tree-fi-clickbox"  mode="radio" ng-click="chooseItem($event,item)"></i>'+
        '      <i ng-if="!radio && item.checked && item.showBox  && showCheckBox" class="fi tree-fi-clickbox" selected="selected" ng-click="chooseItem($event,item)"></i>'+
        '      <i ng-if="!radio && !item.checked && item.showBox  && showCheckBox" class="fi tree-fi-clickbox" ng-click="chooseItem($event,item)"></i>'+
        '      <i ng-if="!item.showBox  && showCheckBox" class="fi tree-fi-clickbox" canchoose="false"></i>'+
        '      <span ng-dblclick="onDblClick($event,item)" ng-if="item.editable===false"  ng-click="rowClick($event,item)"  outer-scope="item.itemRootScope" render-item-class="item.itemClass" render-item-class-locals="{record:item.originData}" >{{item.displayExpress}}</span>'+
        '      <input style="width:50%;"  ng-blur="onBlur($event,item)" ng-keypress="onKeyPress($event,item)" ng-if="item.editable===true && item.readonly===false && item.disabled===false"  outer-scope="item.itemRootScope" render-item-class="item.itemClass" render-item-class-locals="{record:item.originData}" value="{{item.displayExpress}}"/>'+
        '    </div>'+
        '</li>';
        $templateCache.put("/datatree/template",recursiveTemplate);

        //生成结点
        function createNode(item,config){
            var  prop = config.idProp,
                parentProp = config.parentProp,
                hasChildProp = config.hasChildProp,
                valueProp = config.valueProp,
                displayExpress = config.displayExpress,
                showBox = config.showBox,
                isExpandAll = config.isExpandAll,
                async = config.async,
                itemClass = config.itemClass,
                itemRootScope = config.itemRootScope,
                displayItem = config.displayItem,
                editable = config.editable,
                readonlyItem = config.readonlyItem,
                disabledItem = config.disabledItem,
                ele,el,show,display,editable1,readonly,disabled;
            el = item;
            ele = {};
            ele.idProp = el[prop];
            ele.parentProp = el[parentProp];
            ele.valueProp= el[valueProp];
            ele.displayExpress = el[displayExpress];
            ele.showBox = true;
            if(angular.isFunction(showBox())){
                ele.showBox = (showBox()(el)===true);
            }else{
                show = showBox(el);
                if(show!==undefined){
                    ele.showBox = (show===true);
                }
            }
            ele.originData=el;
            ele.checked=false;
            ele.children=[];
            ele.display = true;
            if(angular.isFunction(displayItem())){
                ele.display = (displayItem()(el)===true);
            }else{
                display = displayItem(el);
                if(display!==undefined){
                    ele.display = (display===true);
                }
            }
            ele.editable = false;
            if(angular.isFunction(editable())){
                ele.editable = (editable()(el)===true);
            }else{
                editable1 = editable(el);
                if(editable1!==undefined){
                    ele.editable = (editable1===true);
                }
            }
            ele.readonly = false;
            if(angular.isFunction(readonlyItem())){
                ele.readonly = (readonlyItem()(el)===true);
            }else{
                readonly = readonlyItem(el);
                if(readonly!==undefined){
                    ele.readonly = (readonly===true);
                }
            }

            ele.disabled = false;
            if(angular.isFunction(disabledItem())){
                ele.disabled = (disabledItem()(el)===true);
            }else{
                disabled = disabledItem(el);
                if(disabled!==undefined){
                    ele.disabled = (disabled===true);
                }
            }
            ele.expanded=false;
            if(async==="true"){
                if(el[hasChildProp]==='true' || el[hasChildProp]===true || !hasChildProp){
                    ele.type="branch";
                }else{
                    ele.type="leaf";
                }
            }else{
                ele.type="leaf";
                if(isExpandAll==="true"){
                    ele.expanded=true;
                }
            }
            ele.itemClass = itemClass;
            ele.itemRootScope = itemRootScope;
            return ele;
        }

        //构建树
        function buildTree(source,config) {
            source = angular.copy(source);
            var prop = config.idProp,
                parentProp = config.parentProp,
                results = [],
                fetchChildrenFn,
                margin, i, len, el,ele;
            fetchChildrenFn = function (element, margin) {
                if (margin.length === 0) return;
                var children = [],
                    i, len, el, childrenMargin,ele,show;
                for (i = 0, len = margin.length; i < len; i++) {
                    el = margin[i];
                    if (el[parentProp] === element.idProp) {
                        ele = {};
                        ele = createNode(el,config);
                        children.push(ele);
                        ele = null;
                    }
                }
                childrenMargin = Arrays.subtract(margin, children);
                for (i = 0, len = children.length; i < len; i++) {
                    el = children[i];
                    fetchChildrenFn(el, childrenMargin);
                }
                if (children.length > 0) {
                    element.children = children;
                    element.type="branch";
                }
            }

            if(!source || source.length===0){
                return results;
            }
            for (i = 0, len = source.length; i < len; i++) {
                el = source[i];
                if (!el[parentProp]) {
                    ele = {};
                    ele =  createNode(el,config);
                    results.push(ele);
                    ele = null;
                }
            }
            margin = Arrays.subtract(source, results);
            // copy放在下面是为了subtract使用'==='而不是equals， 效率更高
            for (i = 0, len = results.length; i < len; i++) {
                el = results[i];
                fetchChildrenFn(el, margin);
            }
            return results;
        }

        //加载子结点
        function transcateChildren(records,config){
            var i,len,result,el,ele;
            result=[];
            for(i=0,len=records.length;i<len;i++){
                el = records[i];
                ele = {};
                ele = createNode(el,config)
                result.push(ele);
            }
            return result;
        }


        return {
            restrict: 'E',
            replace:true,
            scope:{
                currentRow:'=',
                sourceName:'@',
                showSelect:'&',
                disabled:'@',
                chooseItems:'=',
                onBeforeSelect:'&',
                onSelect:'&',
                onBeforeCheck:'&',
                onCheck:'&',
                titleExpress:'@',
                onLoadSuccess:'&',
                treeName:'@',
                displayItem:'&',
                editable:'&',
                beforeRename:'&',
                onRename:'&',
                readonlyItem:'&',
                disabledItem:'&',
                beforeExpand:'&',
                onExpand:'&'
            },
            require:['?^ngModel','?^gItemClass'],
            template:template,
            link:function(scope,element,attrs,controllers){
                var displayExpress = attrs.displayExpress,
                    valueProp=attrs.valueProp,
                    parentProp=attrs.parentProp,
                    idProp = attrs.idProp,
                    hasChildProp = attrs.hasChildProp,
                    mode = attrs.mode||'radio',
                    isExpandAll = attrs.isExpandAll || 'false',
                    async = attrs.async || 'false',
                    allowCascadeSelect = attrs.allowCascadeSelect || 'false',
                    allowChooseParent = attrs.allowChooseParent || 'true',
                    width = attrs.width,
                    height = attrs.height,
                    showRechoose = attrs.showRechoose || 'true',
                    showCheckBox = attrs.showCheckBox || 'true',
                    cascadeMode = attrs.cascadeMode || 'default',
                    doubleEdit = attrs.doubleEdit || 'false',
                    config,selectChild,unSelectChildren,clearChooseItems,
                    unitRegExp,initTreeData,ngModel,itemClass,selectParent,cancelOtherEditable;


                scope.async = async;
                //保存当前行数据
                scope.currentRow={};
                ngModel = controllers[0];
                itemClass = controllers[1];
                scope.showCheckBox = showCheckBox==='true';
                //表示数据源中树关系字段
                config = {};
                config.idProp = idProp;
                config.parentProp = parentProp;
                config.hasChildProp = hasChildProp;
                config.valueProp = valueProp;
                config.displayExpress = displayExpress;
                config.async = async;
                config.showBox = scope.showSelect;
                config.isExpandAll = isExpandAll;
                config.itemClass = itemClass;
                config.itemRootScope = scope.$parent;
                config.displayItem=scope.displayItem;
                config.editable = scope.editable;
                config.readonlyItem = scope.readonlyItem;
                config.disabledItem = scope.disabledItem;

                scope.config = config;
                scope.radio = (mode==='radio');
                scope.showRechoose = (showRechoose==='true');
                scope.allowChooseParent = (allowChooseParent==='true');
                //已选中的记录
                scope._chooseItems = [];
                //已经转化好的树型数据
                scope.treeData = [];

                initDataTree(scope.treeName,scope);
                $dataTreeManager.registerDataTree(scope.treeName,scope.dataTree);

                //设置控件的宽度
                unitRegExp = /^[0-9]+(%|in|cm|mm|pt|pc|ex|em|px)?$/g;
                if(width){
                    if(unitRegExp.test(width)){
                        element.css("width",width);
                    }else{
                        throw "宽度设置错误";
                    }
                }
                //设置控件的高度
                unitRegExp = /^[0-9]+(%|in|cm|mm|pt|pc|ex|em|px)?$/g;
                if(height){
                    if(unitRegExp.test(height)){
                        element.css("height",height);
                    }else{
                        throw "高度设置错误";
                    }
                }

                //初始化数据
                initTreeData = function(dataSource){
                    var records,paramArg;
                    records = angular.copy(dataSource.records);
                    if(!scope.source) {
                        scope.source = dataSource;
                    }
                    scope.treeData = buildTree(records,config);
                    paramArg={
                        record:records
                    }
                    scope.onLoadSuccess(paramArg);
                }

                if(async === "false"){
                    scope.$on(scope.sourceName,function(event,dataSource) {
                        //初始化数据
                        initTreeData(dataSource);
                    });
                }else{
                    //加载数据
                    $dataSourceManager.getDataSource(scope.sourceName).then(function(dataSource){
                        dataSource.doRequestData({},initTreeData,true);
                    });
                }

                cancelOtherEditable = function(treeData,item){
                    var i,len,el,id;
                    id=item.idProp;
                    for(i=0, len = treeData.length; i<len; i++){
                        el = treeData[i];
                        if(el.idProp !== id){
                            el.editable=false;
                        }
                        if(el.children && el.children.length>0){
                            arguments.callee(el.children,item);
                        }
                    }
                }
                //结点双击事件
                scope.onDblClick = function($event,item){
                    if(doubleEdit==="true" && item.readonly===false && item.disabled===false && angular.isUndefined(scope.disabled)){
                        //取消其他结点的编辑状态
                        cancelOtherEditable(scope.treeData,item);
                        item.editable = true;
                    }
                }

                //回车失去焦点
                scope.onKeyPress = function($event,item){
                    if($event.keyCode===13){
                        $event.target.blur();
                    }
                }
                //失去焦点事件
                scope.onBlur = function($event,item){
                    var expressValue,beforeRename,onRename,ele,argument;
                    beforeRename=scope.beforeRename;
                    onRename = scope.onRename;
                    ele = item.originData;
                    expressValue = angular.element($event.target).val();
                    argument = {
                        value:expressValue,
                        record:ele
                    }
                    if(beforeRename(argument)!==false){
                        item.displayExpress = expressValue;
                        onRename(argument);
                    }
                    item.editable = false;
                }

                //展开树枝结点函数
                scope.expandNode = function(itemData){
                    var paramArg;
                    if(angular.isUndefined(scope.disabled)){
                        paramArg = {
                            record:itemData.originData
                        }
                        if(itemData.expanded===false){
                            scope.beforeExpand(paramArg);
                            if(async==="true"){
                                scope.source.params[idProp] =itemData.idProp;
                                $dataSourceManager.dataSources[scope.sourceName].doRequestData(scope.source.params,function(_dataSource){
                                    var records,children;
                                    records = angular.copy(_dataSource.records);
                                    if(itemData){
                                        if(!records || records.length===0){
                                          itemData.type="leaf";
                                        }else{
                                          children = transcateChildren(records,config);
                                          angular.extend(itemData.children,children);
                                        }
                                    }
                                 },true);
                            }
                            itemData.expanded=!itemData.expanded;
                            scope.onExpand(paramArg);
                        }else{
                            itemData.expanded=!itemData.expanded;
                        }
                    }
                }
                function canCheck(item){
                    if(item.showBox && !item.checked && angular.isUndefined(scope.disabled) && item.readonly===false && item.disabled === false){
                        return true;
                    }
                    return false;
                }
                
                //选中结点的所有子孙
                selectChild = function(item){
                    var i,len,el,children;
                    children = item.children || [];
                    for(i=0,len=children.length; i<len; i++){
                        el = children[i];
                        //可以选择，并且还没有被选中
                        if(el.showBox === true && el.checked===false){
                            el.checked = true;
                            scope._chooseItems.push(el);
                            if(el.children && el.children.length>0){
                                arguments.callee(el);
                            }
                        }
                    }
                }

                //选中结点的所有父结点
                selectParent = function(item){
                    var parentProp,parentNode;
                    if(cascadeMode && cascadeMode==="limit"){
                        parentProp =  item.parentProp;
                        if(parentProp && parentProp!==""){
                            parentNode = searchNodeByTd(scope.treeData,parentProp);
                            if(parentNode){
                                //可以选择，并且还没有被选中
                                if(parentNode.showBox === true && parentNode.checked===false) {
                                    parentNode.checked = true;
                                    scope._chooseItems.push(parentNode);
                                }
                                arguments.callee(parentNode);
                            }
                        }
                    }
                }
                function canCancelCheck(item){
                    if(item.showBox && item.checked && angular.isUndefined(scope.disabled) && item.readonly===false && item.disabled === false){
                        return true;
                    }
                    return false;
                }
                //从选中数据中删除结点的所有子孙
                unSelectChildren = function(item){
                    var i,len,el,children;
                    children = item.children || [];
                    for(i=0,len=children.length; i<len; i++){
                        el = children[i];
                        //删除已经被选中的结点
                        if(el.showBox === true && el.checked===true){
                            el.checked = false;
                            Arrays.remove(scope._chooseItems,el);
                            if(el.children && el.children.length>0){
                                arguments.callee(el);
                            }
                        }
                    }
                }

                clearChooseItems = function(){
                    var i,len,el;
                    len = scope._chooseItems.length;
                    for(i=0;i<len;i++){
                        el = scope._chooseItems[i];
                        el.checked=false;
                    }
                    scope._chooseItems=[];
                }

                //点击勾选框后执行的函数
                scope.chooseItem = function($event,item){
                    var eventParams,beforeCheck,onCheck,flag=false;
                    eventParams = {
                        $event:$event,
                        record:item.originData
                    }
                    beforeCheck = scope.onBeforeCheck;
                    onCheck = scope.onCheck;

                    //判断是否可选
                    if(item.showBox && angular.isUndefined(scope.disabled) && item.readonly===false && item.disabled === false){
                        if(scope.radio){
                            if(item.type==='leaf'){
                                flag = true;
                            }
                        }else{
                            if(item.type==='leaf'){
                                flag=true;
                            }else if(scope.allowChooseParent){
                                flag=true;
                            }
                        }
                    }

                    if(flag && beforeCheck(eventParams)!==false){
                        scope.rowClick($event,item);
                        item.checked = !item.checked;
                        if(scope.radio){
                            clearChooseItems();
                        }
                        if(item.checked===true){
                            scope._chooseItems.push(item);
                            //级联添加
                            if(allowCascadeSelect==='true' && !scope.radio && async==='false'){
                                selectChild(item);
                                selectParent(item);
                            }
                        }else{
                            Arrays.remove(scope._chooseItems,item);
                            //级联删除
                            if(allowCascadeSelect==='true' && !scope.radio && async==='false'){
                                unSelectChildren(item);
                            }
                        }
                        //onCheck事件
                        onCheck(eventParams);
                    }
                }


                //点击上面选中值文字执行的函数
                scope.deleteChooseItem = function(item){
                    if(angular.isUndefined(scope.disabled)){
                        Arrays.remove(scope._chooseItems,item);
                        item.checked=false;
                        //级联删除
                        if(allowCascadeSelect==='true' && !scope.radio && async==='false'){
                            unSelectChildren(item);
                        }
                    }
                }

                //点击重选执行的函数
                scope.clearChooseItems = function(){
                    if(angular.isUndefined(scope.disabled)){
                        clearChooseItems();
                    }
                }

                //改变当前行函数
                scope.rowClick = function($event,item){
                    var el,beforeSelect,onSelect,selectParams;
                    beforeSelect = scope.onBeforeSelect;
                    onSelect = scope.onSelect;
                    selectParams = {
                        $event: $event,
                        record:item.originData
                    }
                    if(angular.isUndefined(scope.disabled) && beforeSelect(selectParams)!==false){
                        el = item.originData;
                        scope.currentRow = el;
                        onSelect(selectParams)
                    }
                }

                if(ngModel){
                    ngModel.$render = function(){
                        var modelValues,itemValues,items, i,len,el,_i,_len;
                        clearChooseItems();
                        modelValues = ngModel.$viewValue;
                        if(!modelValues) return;
                        if(scope.radio){
                            items = findNodeByValue(scope.treeData,modelValues);
                            if(items && items.length>0){
                                if(items[0].showBox && items[0].type==="leaf"){
                                    items[0].checked = true;
                                    scope._chooseItems.push(items[0]);
                                }
                            }
                        }else{
                            if(modelValues && modelValues.length>0){
                                itemValues = modelValues.split(",");
                            }
                            for(i=0,len=itemValues.length;i<len;i++){
                                items =  findNodeByValue(scope.treeData,itemValues[i]);
                                if(items && items.length>0){
                                    for(_i=0,_len=items.length;_i<_len;_i++){
                                        el = items[_i];
                                        if((el.showBox && scope.allowChooseParent && el.type==="branch") || (el.type==="leaf" && el.showBox)){
                                            el.checked=true;
                                            scope._chooseItems.push(el);
                                        }
                                    }
                                }
                            }
                        }
                    };

                    //当树中已选中项发生改就时，更改ngModel的值。
                    scope.$watchCollection("_chooseItems",function(newValue,oldValue){
                        var chooseItems=[],modelValue="";
                        angular.forEach(newValue,function(item){
                            modelValue += item.valueProp+",";
                            chooseItems.push(item.originData);
                        });
                        scope.chooseItems = chooseItems;
                        chooseItems = null;
                        if(modelValue && modelValue.length>0){
                            modelValue=modelValue.substring(0,modelValue.length-1);
                        }
                        if (ngModel.$viewValue !== modelValue) {
                            if (scope.$root.$$phase) {
                                ngModel.$setViewValue(modelValue);
                            } else {
                                scope.$apply(function () {
                                    ngModel.$setViewValue(modelValue);
                                });
                            }
                        }
                    });
                }
            }
        }
    }
});
