// Generated by CoffeeScript 1.9.3
(function () {
    define([
        "angular",
        "framework/time/CursorPositionUtil",
        "framework/date/Calendar",
        "framework/utils/DBCUtils",
        "framework/snapshot/GillionLocationServiceConstructor",
        "framework/utils/UtilsModule",
        "framework/control/GillionControlDirectiveModule",
        "framework/tabindex/TabindexModule",
        "framework/msg/GillionMsgModule"
    ], function (angular, CursorPositionUtil, Calendar, DBCUtils, GillionLocationServiceConstructor) {
        var DateHandle, DateModule, dateParser, handleCssStyle, ngModelListener, timeRegExp;
        DateModule = angular.module("DateModule", ["TabindexModule", "GillionControlDirectiveModule", "UtilsModule", "GillionMsgModule"]);
        DateModule.service("GillionLocationService", GillionLocationServiceConstructor);
        timeRegExp = /(\d{4})-(\d{2})-(\d{2})?(.*)/;
        dateParser = function (value) {
            var currentDate, dateInfos, day, hour, minute, month, timeInfos, timeStr, year;
            currentDate = new Date();
            dateInfos = value.match(timeRegExp);
            if (dateInfos === null) {
                dateInfos = value.match(/(\d{4})-(\d{2})?(.*)/);
                if (dateInfos === null) {
                    dateInfos = value.match(/(\d{4})?(.*)/);
                    if (dateInfos === null) {
                        return currentDate;
                    } else {
                        year = dateInfos[1];
                    }
                } else {
                    year = dateInfos[1];
                    month = dateInfos[2];
                }
            } else {
                year = dateInfos[1];
                month = dateInfos[2];
                day = dateInfos[3];
                timeStr = dateInfos[4];
            }
            year = parseInt(year, 10);
            month = parseInt(month, 10) - 1;
            day = parseInt(day, 10);
            if (!isNaN(year)) {
                currentDate.setFullYear(year);
            }

            if (!isNaN(day)) {
                currentDate.setDate(day);
            }
            if (!isNaN(month)) {
                currentDate.setMonth(month);
            }
            //再次赋值，防止日期天数超出造成天数不正常
            if (!isNaN(day)) {
                currentDate.setDate(day);
            }

            if (timeStr) {
                timeInfos = timeStr.split(":");
                hour = timeInfos[0];
                minute = timeInfos[1];
                if (hour) {
                    hour = parseInt(hour);
                    if (!isNaN(hour)) {
                        currentDate.setHours(hour);
                    }
                } else {
                    currentDate.setHours(0);
                }
                if (minute) {
                    minute = parseInt(minute);
                    if (!isNaN(minute)) {
                        currentDate.setMinutes(minute);
                    }
                } else {
                    currentDate.setMinutes(0);
                }
                currentDate.setSeconds(0);
            }else{
                currentDate.setHours(0);
                currentDate.setMinutes(0)
                currentDate.setSeconds(0);
                currentDate.setMilliseconds(0);
            }
            return currentDate;
        };
        ngModelListener = function ($scope, $ngModel, value) {
            if (!angular.isDate(value)) {
                if (value !== "") {
                    value = dateParser(value);
                } else {
                    value = void 0;
                }
            }
            if (angular.isDefined($ngModel)) {
                if ($ngModel.$viewValue !== value) {
                    if ($scope.$root.$$phase) {
                        $ngModel.$setViewValue(value);
                        $ngModel.$render();

                    } else {
                        $scope.$apply(function () {
                            $ngModel.$setViewValue(value);
                            $ngModel.$render();
                        });
                    }
                }
            }
        };
        DateHandle = {
            handleYear: function (value, format) {
                if (/(\d{4}(.*))/.test(value)) {
                    year = value.substr(0, 4);
                    if (year === "0000") {
                        return year;
                    }
                }
                if (/(\d{5}?(.*))/.test(value)) {
                    value = value.substr(0, 4) + "-" + value.substr(4, 1);
                }
                value = value.replace(/(\d{2,4})([^0-9]*)?(.*)/, function () {
                    var monthStr, year, yearSeparate;
                    year = arguments[1];
                    yearSeparate = arguments[2];
                    monthStr = arguments[3];
                    if (monthStr) {
                        monthStr = DateHandle.handleMonth(monthStr, format);
                    }
                    if (yearSeparate === "-") {

                        /*判断year的大小，自动填充 */
                        if (year.length === 1) {
                            year = "200" + year;
                        }
                        if (year.length === 2) {
                            year = "20" + year;
                        }
                        if (year.length === 3) {
                            year = "2" + year;
                        }
                        return "" + year + yearSeparate + monthStr;
                    } else {
                        return year;
                    }
                });
                return value;
            },
            handleMonth: function (value, format) {
                var isOnlyMonthType;
                if (/(\d{2}(.*))/.test(value)) {
                    var month = value.substr(0, 2);
                    if (month === "00") {
                        return month;
                    }
                }
                if (!/(d+)|(D+)/.test(format)) {
                    isOnlyMonthType = true;
                }
                if (/(^\d{3}$)/.test(value)) {
                    value = value.substr(0, 2) + "-" + value.substr(2, 1);
                }
                if (/(^\d{2}[^0-9]\d{3}$)/.test(value)) {
                    if (!/(h+)|(H+)/.test(format)) {
                        value = value.substr(0, 5);
                    } else {
                        value = value.substr(0, 5) + " " + value.substr(5, 1);
                    }
                }
                value = value.replace(/(\d{1,2})([^0-9]*)?(.*)/, function () {
                    var dayStr, month, monthNum, monthSeparate;
                    month = arguments[1];
                    monthSeparate = arguments[2];
                    dayStr = arguments[3];
                    if (dayStr) {
                        monthNum = parseInt(month, 10);
                        if (month.length === 2) {
                            if (monthNum > 12) {
                                monthNum = parseInt(monthNum / 10, 10);
                            }
                        }
                        dayStr = monthSeparate + DateHandle.handleDay(dayStr, format, monthNum);
                    } else {
                        dayStr = monthSeparate;
                    }
                    if (isOnlyMonthType) {
                        dayStr = "";
                    }
                    if (monthSeparate === "-") {
                        if (month.length === 1) {
                            if (month === "0") {
                                return "01" + dayStr;
                            } else {
                                return "0" + month + dayStr;
                            }
                        } else {
                            monthNum = parseInt(month, 10);
                            if (monthNum > 12) {
                                month = "0" + (parseInt(monthNum / 10, 10));
                            }
                            return "" + month + dayStr;
                        }
                    } else {
                        monthNum = parseInt(month, 10);
                        if (monthNum > 12) {
                            month = "" + (parseInt(monthNum / 10, 10));
                        }
                        return "" + month;
                    }
                });
                return value;
            },

            /*处理日期中的天数输入 */
            handleDay: function (value, format, month) {
                value = value.replace(/(\d{1,2})([^0-9]*)?(.*)/, function () {
                    /*获取本月最后一天 */
                    var date, day, dayNum, daySeparate, maxDay, timeStr;
                    if (/(\d{2}(.*))/.test(value)) {
                        var day = value.substr(0, 2);
                        if (day === "00") {
                            return day;
                        }
                    }
                    date = new Date();
                    date.setMonth(month);
                    date.setDate(0);
                    maxDay = date.getDate();
                    day = arguments[1];
                    daySeparate = arguments[2];
                    timeStr = arguments[3];
                    if (timeStr) {
                        timeStr = DateHandle.handleHour(timeStr, format);
                    }
                    dayNum = parseInt(day, 10);
                    if (daySeparate === " ") {
                        if (day.length === 1) {
                            if (day === "0") {
                                return "01" + daySeparate + timeStr;
                            } else {
                                return "0" + day + daySeparate + timeStr;
                            }
                        } else {
                            if (dayNum > maxDay) {
                                day = "0" + (parseInt(dayNum / 10, 10));
                            }
                            return "" + day + daySeparate + timeStr;
                        }
                    } else {
                        if (dayNum > maxDay) {
                            day = "0" + (parseInt(dayNum / 10, 10));
                        }
                        return "" + day;
                    }
                });
                return value;
            },

            /*处理日期中的小时输入 */
            handleHour: function (value, format) {
                if (/(^\d{3}$)/.test(value)) {
                    value = value.substr(0, 2) + ":" + value.substr(2, 1);
                }
                value = value.replace(/(\d{1,2})([^0-9]*)?(.*)/, function () {
                    var hour, hourNum, hourSeparate, minuteStr;
                    hour = arguments[1];
                    hourSeparate = arguments[2];
                    minuteStr = arguments[3];
                    if (minuteStr) {
                        minuteStr = DateHandle.handlerMinute(minuteStr);
                    }
                    if (hourSeparate === ":") {
                        if (hour.length === 1) {
                            return "0" + hour + hourSeparate + minuteStr;
                        } else {
                            hourNum = parseInt(hour, 10);
                            if (/(H+)/.test(format)) {
                                if (hourNum > 23) {
                                    hour = "0" + parseInt(hourNum / 10, 10);
                                }
                            } else {
                                if (hourNum > 11) {
                                    hour = "0" + parseInt(hourNum / 10, 10);
                                }
                            }
                            return "" + hour + hourSeparate + minuteStr;
                        }
                    } else {
                        if (hour.length === 1) {
                            return "" + hour;
                        } else {
                            hourNum = parseInt(hour, 10);
                            if (/(H+)/.test(format)) {
                                if (hourNum > 23) {
                                    hour = "0" + parseInt(hourNum / 10, 10);
                                }
                            } else {
                                if (hourNum > 11) {
                                    hour = "0" + parseInt(hourNum / 10, 10);
                                }
                            }
                        }
                        return hour;
                    }
                });
                return value;
            },

            /*处理日期中的分钟输入 */
            handlerMinute: function (value) {
                value = value.replace(/(\d{1,2})([^0-9]*)?(.*)/, function () {
                    var minute, minuteNum;
                    minute = arguments[1];
                    if (minute.length === 1) {
                        return "" + minute;
                    } else {
                        minuteNum = parseInt(minute, 10);
                        if (minuteNum > 59) {
                            minute = "0" + (parseInt(minute / 10, 10));
                        }
                    }
                    return "" + minute;
                });
                return value;
            }
        };
        handleCssStyle = function ($scope, $element) {
            if ($scope.cssStyle) {
                return angular.extend($scope.dateWidgetStyle, $scope.cssStyle);
            }
        };
        DateModule.directive("gDate", function ($parse, $compile, $rootScope, $tabindex,$timeout,GillionMsgService) {
            var template;
            template = '<div class="form-date" verify-target ng-style="dateWidgetStyle">\n    <input type="text" ng-dblclick="selectInputText()" ng-disabled="ngDisabled||disabled" ng-keypress="dateKeyPress($event)"\n           ng-keyup="dateKeyUp($event)" ng-click="showCalendar()" ng-focus="showCalendar()"\n           ng-blur="confirmDate($event)" class="form-text date-text-input">\n    <a type="button" class="btn">\n        <i class="fi fi-date" ng-click="showCalendar()"></i>\n    </a>\n</div>';
            return {
                template: template,
                replace: true,
                restrict: "E",
                scope: {
                    format: "@",
                    defaultDate: "@",
                    disabled: "=",
                    cssStyle: "=",
                    ngDisabled: "=",
                    beforeSelect:"&",
                    afterSelect:"&"
                },
                require: "^?ngModel",
                controller: function ($scope, $element) {
                    var inputElement;
                    inputElement = $element.find("input");
                    /*为控件注册tabIndex服务 */
                    $tabindex.register(inputElement, $element);
                },
                link: function ($scope, $element, $attr, $ctrl) {
                    var $calendar, $ngModel, dateInputEle, defaultDate, format, inputElement, keyFlag, selectedDate;
                    inputElement = $element.find(".date-text-input");
                    if (angular.isDefined($attr.name)) {
                        inputElement.attr("name", $attr.name);
                        $element.removeAttr("name");
                    }



                    angular.element(window).on("scroll",function(){
                        //触发blur
                        $timeout(function(){
                            inputElement.trigger("blur");
                        });
                    });

                    /*初始化日历对象，全局保持一个,存放到rootScope里 */
                    if (angular.isUndefined($rootScope.calendar)) {
                        $calendar = new Calendar($compile, $rootScope, $parse);
                        $rootScope.calendar = $calendar;
                    } else {
                        $calendar = $rootScope.calendar;
                    }
                    if ($attr.width) {
                        $scope.dateWidgetStyle = {
                            width: $attr.width
                        };
                    }
                    handleCssStyle($scope, $element);
                    format = $scope.format || "YYYY-MM-DD";

                    /*初始化日历，打开时，默认的值，若不存在，则默认打开日历时显示当前日期 */
                    if (angular.isUndefined($scope.defaultDate)) {
                        defaultDate = new Date();
                    } else {
                        if (angular.isNumber($scope.defaultDate)) {
                            defaultDate = new Date($scope.defaultDate);
                        }
                        if (angular.isDate($scope.defaultDate)) {
                            defaultDate = $scope.defaultDate;
                        }
                        if (angular.isString($scope.defaultDate)) {
                            defaultDate = dateParser($scope.defaultDate);
                        }
                    }
                    dateInputEle = $element.find(".date-text-input");
                    $ngModel = $ctrl;
                    selectedDate = void 0;

                    /*将ng-model的值绑定到日期文本域上 */
                    if (angular.isDefined($ngModel)) {
                        $ngModel.$render = function () {
                            var dateStr;
                            if (angular.isDefined($ngModel.$viewValue)) {

                                /*判断值类型，根据不同值类型，去实例化日期对象 */
                                if (angular.isNumber($ngModel.$viewValue)) {
                                    selectedDate = new Date($ngModel.$viewValue);
                                }
                                if (angular.isDate($ngModel.$viewValue)) {
                                    selectedDate = $ngModel.$viewValue;
                                }
                                if (angular.isString($ngModel.$viewValue)) {
                                    if ($ngModel.$viewValue === "") {
                                        selectedDate = void 0;
                                    } else {
                                        if ($ngModel.$viewValue.indexOf("T") != -1) {
                                            var formatValue = $parse("date|dateFormatter:'" + format + "'")({
                                                "date": $ngModel.$viewValue
                                            });
                                            selectedDate = dateParser(formatValue);
                                        } else {
                                            selectedDate = dateParser($ngModel.$viewValue);
                                        }

                                    }
                                }

                                /*设置文本框的值 */
                                dateStr = $parse("date|dateFormatter:'" + format + "'")({
                                    "date": selectedDate
                                });
                                dateInputEle.val(dateStr);

								/*引起死循环*/
                                /*if(angular.isString($ngModel.$modelValue)){
                                    ngModelListener.call(this, $scope, $ngModel, dateStr);
                                }*/
                            } else {
                                dateInputEle.val("");
                            }
                            //修复因类型原因，引起的校验问题
                            if(angular.isDefined($ngModel.verify)){
                                $ngModel.verify();
                            }
                        };
                    }
                    /*点击文本框事件，根据文本框的值重新刷新日历，并显示日历 */
                    var isShowCalendar = true;
                    $scope.showCalendar = function () {
                        if(GillionMsgService.isUnderMasked($element[0])){
                            return;
                        }
                        if(!isShowCalendar){
                            isShowCalendar = true;
                            return;
                        }
                        if (!$scope.disabled && !$scope.ngDisabled && $attr.disabled!=="disabled" && $attr.disabled!== "true") {
                            selectedDate = dateInputEle.val();

                            /*判断文本框内是X否有值，若有，则将文本框内的值初始化到日历选择页面上，若没有，则以初始值进行显示 */
                            if (selectedDate) {
                                selectedDate = dateParser(selectedDate);

                                /*是否有效日期，若为无效日期，则弹出的日历显示默认值 */
                                if (isNaN(selectedDate.getTime())) {
                                    $calendar.refresh(defaultDate, $element, void 0, format);
                                } else {
                                    $calendar.refresh(defaultDate, $element, selectedDate, format);
                                }
                            } else {
                                $calendar.refresh(defaultDate, $element, void 0, format);
                            }
                            $calendar.showCalendar($element);

                            /*日期选择回调时间初始化 */
                            $calendar.chooseDate(function (date,focusInput) {
                                var beforeSelect = $scope.beforeSelect(),
                                    afterSelect = $scope.afterSelect(),
                                    dateStr = $parse("date|dateFormatter:'" + format + "'")({
                                        "date": date
                                    });;
                                if(angular.isFunction(beforeSelect)){
                                    if(beforeSelect(date) === false){
                                        return;
                                    }
                                }
                                if ($ngModel) {
                                    ngModelListener.call(this, $scope, $ngModel, dateStr);
                                } else {
                                    dateInputEle.val(dateStr);
                                }
                                if(angular.isFunction(afterSelect)){
                                    afterSelect(date);
                                }
                                if(focusInput !== false){
                                    inputElement.focus();
                                    isShowCalendar = false;
                                }
                            });

                            /*日期点击确认按钮后，值回写 */
                            $calendar.confirm(function (date,focusInput) {
                                var beforeSelect = $scope.beforeSelect(),
                                    afterSelect = $scope.afterSelect(),
                                    dateStr = $parse("date|dateFormatter:'" + format + "'")({
                                        "date": date
                                    });

                                if(angular.isFunction(beforeSelect)){
                                    if(beforeSelect(date) === false){
                                        return;
                                    }
                                }
                                if ($ngModel) {
                                    ngModelListener.call(this, $scope, $ngModel, dateStr);
                                } else {
                                    dateInputEle.val(dateStr);
                                }
                                if(angular.isFunction(afterSelect)){
                                    afterSelect(date);
                                }
                                if(focusInput !== false){
                                    inputElement.focus();
                                    isShowCalendar = false;
                                }
                            });

                            /*日期点击清除时，值回填 */
                            $calendar.clear(function () {
                                if ($ngModel) {
                                    ngModelListener.call(this, $scope, $ngModel, "");
                                }
                                dateInputEle.val("");
                            });
                        }
                    };

                    /*表单输入控制 */
                    keyFlag = false;

                    /*防止按住按键重复输入 */
                    $scope.dateKeyPress = function ($event) {
                        var keyCode, keyflag;
                        keyCode = $event.keyCode;
                        if (!((keyCode > 47 && keyCode < 58) || keyCode === 45 || (keyCode === 58 && $event.shiftKey) || keyCode === 32)) {
                            $event.preventDefault();
                            return;
                        }
                        if (keyflag) {
                            $event.preventDefault();
                        } else {
                            keyflag = true;
                        }
                    };

                    /*日期格式控制 */
                    $scope.dateKeyUp = function ($event) {
                        var element, keyflag, nowLength, orginLength, pos, value;
                        element = angular.element($event.srcElement || $event.target);
                        value = element.val();
                        value = DBCUtils.toCDB(value);
                        pos = CursorPositionUtil.getPosition(element);
                        orginLength = value.length;
                        value = DateHandle.handleYear(value, format);
                        nowLength = value.length;
                        element.val(value);
                        CursorPositionUtil.setPosition(element, pos + nowLength - orginLength);
                        selectedDate = dateParser(value);
                        if (!isNaN(selectedDate.getTime())) {
                            $calendar.setSelectDate(selectedDate);
                        }
                        if (value === "") {
                            ngModelListener.call(this, $scope, $ngModel, value);
                            return;
                        }
                        if (format.toLowerCase() === 'yyyy-mm') {
                            if (/\d{4}-\d{2}/.test(value)) {
                                ngModelListener.call(this, $scope, $ngModel, value);
                            }
                        }
                        if (format.toLowerCase() === 'yyyy-mm-dd') {
                            if (/\d{4}-\d{2}-\d{2}/.test(value)) {
                                ngModelListener.call(this, $scope, $ngModel, value);
                            }
                        }
                        if (format.toLowerCase() === 'yyyy-mm-dd hh:mm') {
                            if (/\d{4}-\d{2}-\d{2} \d{2}:\d{2}/.test(value)) {
                                ngModelListener.call(this, $scope, $ngModel, value);
                            }
                        }
                        keyflag = false;
                    };
                    $scope.confirmDate = function ($event) {
                        var element, value;
                        element = angular.element($event.srcElement || $event.target);
                        value = element.val();
                        if (format.toLowerCase() === 'yyyy-mm') {
                            if (/^\d{4}-\d{1}$/.test(value)) {
                                if (value.substr(5, 1) == '0') {
                                    value = value.substr(0, 5) + "01";
                                } else {
                                    value = value.substr(0, 5) + "0" + value.substr(5, 1);
                                }
                                value = value.substr(0, 5) + "0" + value.substr(5, 1);
                            }
                            if (!/^\d{4}-\d{2}$/.test(value)) {
                                element.val("");
                                ngModelListener.call(this, $scope, $ngModel, "");
                            } else {
                                var date = dateParser(value);
                                element.val(value);
                                ngModelListener.call(this, $scope, $ngModel, date);
                            }
                        }
                        if (format.toLowerCase() === 'yyyy-mm-dd') {
                            if (/^\d{4}-\d{2}-\d{1}$/.test(value)) {
                                if (value.substr(8, 1) == '0') {
                                    value = value.substr(0, 8) + "01";
                                } else {
                                    value = value.substr(0, 8) + "0" + value.substr(8, 1);
                                }

                            }
                            if (!/^\d{4}-\d{2}-\d{2}$/.test(value)) {
                                element.val("");
                                ngModelListener.call(this, $scope, $ngModel, "");
                            } else {
                                var date = dateParser(value);
                                element.val(value);
                                ngModelListener.call(this, $scope, $ngModel, date);
                            }
                        }
                        if (format.toLowerCase() === 'yyyy-mm-dd hh:mm') {
                            if (/^\d{4}-\d{2}-\d{2} \d{2}:\d{1}$/.test(value)) {
                                if (value.substr(14, 1) == '0') {
                                    value = value.substr(0, 14) + "00";
                                } else {
                                    value = value.substr(0, 14) + "0" + value.substr(14, 1);
                                }

                            }
                            if (!/^\d{4}-\d{2}-\d{2} \d{2}:\d{2}$/.test(value)) {
                                value = element.val("");
                                return ngModelListener.call(this, $scope, $ngModel, "");
                            } else {
                                var date = dateParser(value);
                                element.val(value);
                                ngModelListener.call(this, $scope, $ngModel, date);
                            }
                        }
                    };

                    $scope.selectInputText = function(){
                        inputElement.select();
                    }
                }
            };
        });
        return DateModule;
    });

}).call(this);
