控件兼容效验
==========

因为自定义效验时， 加上 `ng-model` 指令的 `Dom对象` 可能不是需要效验的表单控件。
且有可能 `ng-model` 绑定的 `Dom对象` 被容器包裹， 不是需要发送错误消息的 `Dom` 对象
所以需要做如下适配.

1. 当实际的 `input Dom` 在指令生成的 `html` 内时

```html
<input type="number" name="age" ng-model="age" g-number-splitter>
```
  _生成 ==>_

```html
<!-- 希望错误消息 tooltip 以最外层容器作显示目标对象 START -->
<span class="number-splitter" msg-target>
    <span>+</span>
    <!-- 实际模板dom START -->
    <input type="number" ng-model="age" name="age" id="" g-number-splitter msg-target/>
    <!-- 实际模板dom END -->
    <span>-</span>
</span>
<!-- 希望错误消息 tooltip 以最外层容器作显示目标对象 END -->
```

上述情况需要在实际模板生成的 `Dom对象` 和 `JS` 代码包裹的 `Dom` 上加入 `msg-target` 属性

2. 当模板中已有 `Dom容器对象` ， 而不希望以该容器为显示目标对象时

```html
<g-select ng-model="sex" name="sex"></g-select>
```

  _生成 ==>_

```html
<!-- 实际模板dom START -->
<span ng-model="sex" name="sex" verify-target>
    <!-- 希望错误消息 tooltip 以最外层容器作显示目标对象 START -->
    <span verify-target>
        <input type="text">
        <button type="button">查找</button>
    </span>
    <!-- 希望错误消息 tooltip 以最外层容器作显示目标对象 END -->
    <ul>
    <li>选项1</li>
    <li>选项2</li>
    <li>选项3</li>
    <li>选项4</li>
    <li>选项5</li>
    </ul>
</span>
<!-- 实际模板dom END -->
```

上述情况需要在实际模板生成的 `Dom对象` 和 `JS` 代码包裹的 `Dom` 上加入 `verify-target` 属性
