// Generated by CoffeeScript 1.9.3
(function() {
    define(["angular"], function(angular) {
        var ExportExcelService, exportExcelService;
        ExportExcelService = (function() {
            var createIframe,getDataSourceParams,getResponseMessage,id=0;
            function ExportExcelService($http1,$rootScope1) {
                this.$http = $http1;
                this.$rootScope = $rootScope1;
                this.url="/gillion-web/export/excel";
            }

            ExportExcelService.prototype.exportBackData = function(sourceName,key,isPrintAll,url,domain,callback){
                var  me,dataSource,params,requestUrl,el,item,ele,iframe,argumentStr="";
                me = this;
                dataSource = me.$rootScope.dataSources[sourceName];
                params = getDataSourceParams(dataSource);
                if(angular.isFunction(params)){
                    params = params();
                }
                params.key = key;
                params.isPrintAll = isPrintAll || "";
                params.domain = domain || "";
                if(url){
                    requestUrl =url;
                }else{
                    requestUrl = me.url;
                }
                for(el in params){
                    ele = params[el];
                    if(angular.isArray(ele)){
                        for(item in ele){
                            argumentStr = argumentStr+ el +"="+encodeURIComponent(JSON.stringify(ele[item]))+"&";
                        }
                    }else{
                        argumentStr = argumentStr+ el +"="+encodeURIComponent(ele)+"&";
                    }
                }
                if(argumentStr.length>0){
                    requestUrl = requestUrl +"?"+argumentStr.substr(0,argumentStr.length-1);
                }
                iframe = createIframe(requestUrl);
                getResponseMessage(iframe,callback);
            }

            //打印后台数据
            ExportExcelService.prototype.export=function(sourceName,key,isPrintAll,url,domain,callback){
                this.exportBackData(sourceName,key,isPrintAll,url,domain,callback);
            }

            //打印前台数据
            ExportExcelService.prototype.exportData = function(data,key,callback,url,domain){
                var iframe,form,input1,input2,input3,el,item,ele;
                var i,j,ojb;
                //创建iframe
                iframe = angular.element('<iframe src="javascript:false;" />');
                iframe.attr("name","exportExcel"+id);
                iframe.attr("id",id);
                id = id+1;
                iframe.css("display", "none");
                angular.element(document.body).append(iframe);
                //获取结果
                getResponseMessage(iframe[0],callback);
                //日期的处理
                if(data && data.length>0){
                    for(i in data){
                        ojb = data[i];
                        if(ojb && ojb.length>0){
                            for(j in ojb){
                                if(angular.isDate(ojb[j])){
                                    ojb[j] = ojb[j].toISOString();
                                }
                            }
                        }
                    }
                }
                data = JSON.stringify(data);
                //创建form
                form = angular.element("<form method='post'></form>");
                form.attr("style","display:none");
                form.attr("action",url);
                form.attr("target",iframe.attr("name"));
                input1 = angular.element("<input type='hidden' name='key'/>");
                input1.attr("value",key);
                form.append(input1);
                input2 = angular.element("<input type='hidden' name='data'/>");
                input2.attr("value",data);
                form.append(input2);
                if(domain){
                    input3 = angular.element("<input type='hidden' name='domain''/>");
                    input3.attr("value",domain);
                    form.append(input3);
                }
                //提交表单
                form.submit();
                //移删除表单

                form.remove();


            }

            //从dataSource中获取参数
            getDataSourceParams = function(dataSource){
                var params,ele;
                params = angular.copy(dataSource.params);
                if(angular.isFunction(params)){
                    params = params();
                }
                for(ele in params){
                    if(angular.isDate(params[ele])){
                        params[ele] = params[ele].toISOString();
                    }
                    if(!params[ele]){
                        params[ele] = "";
                    }
                }
                if(!params){
                    params = {};
                }
                params.url = angular.copy(dataSource.url);
                if(dataSource.pageSize){
                    params.pageSize =  angular.copy(dataSource.pageSize);
                }
                if(dataSource.currentPage){
                    params.currentPage =  angular.copy(dataSource.currentPage);
                }
                if(dataSource.sortName){
                    params.sortName =  angular.copy(dataSource.sortName);
                }
                if(dataSource.sortDirection){
                    params.sortDirection =  angular.copy(dataSource.sortDirection);
                }
                return params;
            }

            //创建iframe对象
            createIframe = function(requestUrl){
                var iframe;
                iframe = document.createElement("iframe");
                iframe.src = requestUrl;
                iframe.id = "exportexcel"+id;
                id = id +1;
                iframe.style.display = "none";
                document.body.appendChild(iframe);
                return iframe;
            }

            //获取返回值
            getResponseMessage = function(iframe,callback){
                var doc,response,Msg;
                Msg = angular.element(document).injector().get("GillionMsg");
                angular.element(iframe).on('load', function() {
                    doc = iframe.contentDocument ? iframe.contentDocument : window.frames[iframe.id].document;
                    if(doc){
                        if (doc.readyState && doc.readyState !== 'complete') {
                            angular.element(iframe).remove();
                            return;
                        }
                        if (doc.body && doc.body.innerHtml === 'false') {
                            angular.element(iframe).remove();
                            return;
                        }
                        if (doc.XMLDocument) {
                            response = doc.XMLDocument;
                        } else if (doc.body) {
                            response = doc.body.innerHTML;
                        }else {
                            response = {};
                        }
                        if (response) {
                            try {
                                response =new Function("return"+response)();
                                if(!angular.isUndefined(callback)){
                                    callback(response);
                                }else{
                                    if (!response.success) {
                                        Msg.alert("提示信息", response.errorMessages);
                                    }
                                }
                            } catch (_error) {
                                e = _error;
                                Msg.alert("提示信息", "导出失败，请重试");
                            }
                        }
                    }
                    angular.element(iframe).remove();
                });

                angular.element(iframe).on('error', function() {
                    angular.element(iframe).remove();
                });
            }
            return ExportExcelService;
        })();

        exportExcelService = void 0;
        return function($http,$rootScope) {
            if (angular.isUndefined(exportExcelService)) {
                exportExcelService = new ExportExcelService($http,$rootScope);
            }
            return exportExcelService;
        };
    });
}).call(this)