/**
 * Created by huangzx on 2015/6/12.
 */
define('framework/menu/GillionMenuModule', [
    'angular',
    'css!../../../css/menu.css'
], function(angular) {
    return angular.module('GillionMenuModule', []).
        directive('gMenu', function(){
            //逐层加载子菜单
            function showMenu($item, item) {
                var children = item.children;
                if (!children || children.length == 0) return;
                $item.append('<span>+</span>');
                var $ul = angular.element('<ul style="display: none"></ul>');
                $item.append($ul);
                $item.hover(function(){
                    $ul.show();
                    return false;
                }, function(){
                    $ul.hide();
                    return false;
                });
                angular.forEach(children, function(child){
                    var $child = angular.element('<li>' + child.text + '</li>');
                    child.handler && $child.on('click', child.handler);
                    $ul.append($child);
                    showMenu($child, child);
                });
            }

            return {
                restrict: 'E',
                scope:{
                    items:'='
                },
                replace:true,
                template: '<ul></ul>',
                link: function(scope, iEle, iAttrs) {
                    angular.forEach(scope.items, function(item) {
                        var $item = angular.element('<li>' + item.text + '</li>');
                        item.handler && $item.on('click', item.handler);
                        iEle.append($item);
                        showMenu($item, item);
                    });
                }
            };
        });
});