// Generated by CoffeeScript 1.9.3
(function () {
    define(["angular", "framework/time/CursorPositionUtil", "framework/time/TimePane", "framework/utils/DBCUtils", "framework/tabindex/TabindexModule"], function (angular, CursorPositionUtil, TimePane, DBCUtils) {
        var TimeHandler, TimeModule, ngModelListener;
        TimeModule = angular.module("TimeModule", ['TabindexModule']);
        ngModelListener = function ($scope, $ctrl, value) {
            if (angular.isDefined($ctrl)) {
                if ($ctrl.$viewValue !== value) {
                    if ($scope.$root.$$phase) {
                        return $ctrl.$setViewValue(value);
                    } else {
                        return $scope.$apply(function () {
                            return $ctrl.$setViewValue(value);
                        });
                    }
                }
            }
        };
        TimeHandler = {

            /*处理时间中的小时输入 */
            handlerHour: function (timeStr, format) {
                var value;
                value = timeStr.replace(/(\d{1,2})([^0-9]*)?(.*)/, function () {
                    var hour, hourNum, hourSeparate, minuteStr;
                    hour = arguments[1];
                    hourSeparate = arguments[2];
                    minuteStr = arguments[3];
                    if (minuteStr) {
                        minuteStr = TimeHandler.handlerMinute(minuteStr);
                    }
                    if (hourSeparate === ":") {
                        if (hour.length === 1) {
                            return "0" + hour + hourSeparate + minuteStr;
                        } else {
                            hourNum = parseInt(hour, 10);
                            if (/(H+)/.test(format)) {
                                if (hourNum > 23) {
                                    hour = "0" + parseInt(hourNum / 10, 10);
                                }
                            } else {
                                if (hourNum > 11) {
                                    hour = "0" + parseInt(hourNum / 10, 10);
                                }
                            }
                            return "" + hour + hourSeparate + minuteStr;
                        }
                    } else {
                        if (hour.length === 1) {
                            return "" + hour;
                        } else {
                            hourNum = parseInt(hour, 10);
                            if (/(H+)/.test(format)) {
                                if (hourNum > 23) {
                                    hour = "0" + parseInt(hourNum / 10, 10);
                                }
                            } else {
                                if (hourNum > 11) {
                                    hour = "0" + parseInt(hourNum / 10, 10);
                                }
                            }
                        }
                        return hour;
                    }
                });
                return value;
            },

            /*处理时间中的分钟输入 */
            handlerMinute: function (value) {
                value = value.replace(/(\d{1,2})([^0-9]*)?(.*)/, function () {
                    var minute, minuteNum;
                    minute = arguments[1];
                    if (minute.length === 1) {
                        return "" + minute;
                    } else {
                        minuteNum = parseInt(minute, 10);
                        if (minuteNum > 59) {
                            minute = "0" + (parseInt(minute / 10, 10));
                        }
                    }
                    return "" + minute;
                });
                return value;
            }
        };
        TimeModule.directive("gTime", function ($filter, $rootScope, $compile, $parse, $tabindex,$timeout) {
            var template;
            template = "<div class=\"form-time\" verify-target> <input ng-disabled=\"ngDisabled\" ng-dblclick=\"selectInputText()\" ng-blur=\"confirmTime($event)\" ng-click=\"showTimepane()\" ng-keypress=\"preventTypeLetter($event)\" type=\"text\" class=\"form-text\" ng-keyup=\"typeTime($event)\" ng-focus=\"showTimepane()\" > <a type=\"button\" class=\"btn\" ng-click=\"showTimepane()\"> <i class=\"fi fi-time\"></i> </a> </div>";
            return {
                restrict: "E",
                scope: {
                    defaultTime: "@",
                    pattern: "@",
                    width: "@",
                    cssClass: "@",
                    cssStyle: "@",
                    ngDisabled: "="
                },
                require: ["^?ngModel"],
                replace: true,
                template: template,
                controller: function ($scope, $element) {
                    var inputElement;
                    inputElement = $element.find("input");

                    /*为控件注册tabIndex服务 */
                    $tabindex.register(inputElement, $element);
                },
                link: function ($scope, $element, $attrs, $ctrl) {
                    var $ngModel, defaultTime, inputElement, isHour24, key, keyflag, ref, value;
                    inputElement = $element.find("input");
                    if (angular.isDefined($attrs.name)) {
                        inputElement.attr("name", $attrs.name);
                        $element.removeAttr("name");
                    }
                    $scope.$watch("ngDisabled", function (newVal, oldVal) {
                        if (newVal === "disabled") {
                            return $element.attr("disabled", "disabled");
                        } else {
                            return $element.removeAttr("disabled");
                        }
                        //$scope.ngDisabled= newVal;
                    });
                    if (angular.isUndefined($rootScope.$time)) {
                        $rootScope.time = new TimePane($compile, $rootScope, $parse);
                    }

                    /*CSS，style，width处理 */
                    if (angular.isDefined($scope.width)) {
                        $element.css("width", $scope.width);
                    }
                    if (angular.isDefined($scope.cssClass)) {
                        $element.addClass($scope.cssClass);
                    }
                    if (angular.isDefined($scope.cssStyle)) {
                        $scope.cssStyle = $scope.$eval($scope.cssStyle);
                        ref = $scope.cssStyle;
                        for (key in ref) {
                            value = ref[key];
                            $element.css(key, value);
                        }
                    }

                    /*默认日期处理 */
                    defaultTime = $scope.defaultTime;
                    $scope.pattern = $scope.pattern || "HH:mm";
                    isHour24 = /H+/.test($scope.pattern);

                    /*双向绑定 */
                    $ngModel = $ctrl[0];
                    if (angular.isDefined($ngModel)) {
                        $ngModel.$render = function () {
                            var showHour, showMinute, timeInfos;
                            if (!$ngModel.$isEmpty($ngModel.$viewValue)) {
                                value = $ngModel.$viewValue;
                                timeInfos = value.split(":");
                                showHour = parseInt(timeInfos[0], 10);
                                showMinute = parseInt(timeInfos[1], 10);
                                if (!isHour24 && showHour > 12) {
                                    showHour = parseInt(showHour / 12, 10);
                                }
                                showMinute = showMinute < 10 ? "0" + showMinute : "" + showMinute;
                                showHour = showHour < 10 ? "0" + showHour : "" + showHour;
                                return $element.find(".form-text").val(showHour + ":" + showMinute);
                            } else {
                                return $element.find(".form-text").val("");
                            }
                        };
                    }
                    $scope.showTimepane = function () {
                        var date, showHour, showMinute, timeInfos;
                        if (!$scope.ngDisabled) {
                            value = $element.find(".form-text").val();
                            if (!value) {

                                /*若值为空，则默认打开时间为设置的默认时间或当前时间 */
                                defaultTime = $scope.defaultTime;
                                if (angular.isUndefined(defaultTime)) {
                                    date = new Date();
                                    showHour = date.getHours();
                                    showMinute = date.getMinutes();
                                } else {
                                    timeInfos = defaultTime.split(":");
                                    showHour = parseInt(timeInfos[0], 10);
                                    showMinute = parseInt(timeInfos[1], 10);
                                }
                                if (!isHour24 && showHour > 12) {
                                    showHour = parseInt(showHour / 12, 10);
                                }
                                showMinute = showMinute < 10 ? "0" + showMinute : "" + showMinute;
                                showHour = showHour < 10 ? "0" + showHour : "" + showHour;
                                value = showHour + ":" + showMinute;
                            }
                            $rootScope.time.refresh(value, $element, isHour24);
                            $rootScope.time.showTimepane();
                            $rootScope.time.change(function (value) {
                                $element.find(".form-text").val(value);
                                ngModelListener($scope, $ngModel, value);
                            });
                        } else {
                            inputElement.blur();
                        }
                    };

                    /*阻止重复输入 */
                    keyflag = false;
                    $scope.preventTypeLetter = function ($event) {
                        var element, keyCode;
                        element = angular.element($event.srcElement || $event.target);
                        keyCode = $event.keyCode;
                        if ($scope.disabled === "disabled" && keyCode !== 32) {
                            inputElement.blur();
                            $event.preventDefault();
                            return;
                        }
                        if (!((keyCode > 47 && keyCode < 58) || keyCode === 45 || (keyCode === 58 && $event.shiftKey))) {
                            $event.preventDefault();
                            return;
                        }
                        if (keyflag) {
                            $event.preventDefault();
                        } else {
                            keyflag = true;
                        }
                    };

                    /*时间输入事件监听 */
                    $scope.typeTime = function ($event) {
                        var element, nowLength, orginLength, pos;
                        element = angular.element($event.srcElement || $event.target);
                        value = element.val();
                        value = DBCUtils.toCDB(value);
                        pos = CursorPositionUtil.getPosition(element);
                        orginLength = value.length;
                        value = TimeHandler.handlerHour(value, $scope.pattern);
                        element.val(value);
                        nowLength = value.length;
                        CursorPositionUtil.setPosition(element, pos + nowLength - orginLength);
                        if (value) {
                            $rootScope.time.refresh(value);
                        }
                        ngModelListener($scope, $ngModel, value);
                        keyflag = false;
                    };

                    $scope.confirmTime = function ($event) {
                        var element, value;
                        element = angular.element($event.srcElement || $event.target);
                        value = element.val();
                        if (/^\d{2}:\d{1}$/.test(value)) {
                            if (value.substr(3, 1) == '0') {
                                value = value.substr(0, 3) + "00";
                            } else {
                                value = value.substr(0, 3) + "0" + value.substr(3, 1);
                            }
                            element.val(value);
                        }
                        if (!/^\d{2}:\d{2}$/.test(value)) {
                            element.val("");
                            ngModelListener($scope, $ngModel, "");
                        } else {
                            ngModelListener($scope, $ngModel, value);
                        }


                    };


                    $scope.selectInputText = function(){
                        inputElement.select();
                    }
                }

            };
        });
        return TimeModule;
    });

}).call(this);
