// Generated by CoffeeScript 1.9.3
(function () {
    define(["angular", "framework/time/CursorPositionUtil", "framework/utils/DBCUtils"], function (angular, CursorPositionUtil, DBCUtils) {
        var TimePane, initGlobalTimeEvent, timePaneTemplate;
        timePaneTemplate = "<div class=\"dropdown-menu\" ng-style=\"time.timepaneStyle\"> <div class=\"form-time-set\"> <a class=\"btn\"><i class=\"fi fi-arrow-up\" ng-click=\"time.increaseHour()\"></i></a> <input type=\"text\" class=\"time-hour-input\" ng-keypress=\"time.hourKeyPress($event)\" ng-model=\"time.hour\" ng-keyup=\"time.hourKeyUp($event)\"> <a class=\"btn\"> <i class=\"fi fi-arrow-down\" ng-click=\"time.decreaseHour()\"></i> </a> </div> <div class=\"form-time-split\">:</div> <div class=\"form-time-set\"> <a class=\"btn\"> <i class=\"fi fi-arrow-up\" ng-click=\"time.increaseMinute()\"> </i> </a> <input type=\"text\" ng-keypress=\"time.minuteKeyPress($event)\" ng-keyup=\"time.minuteKeyUp($event)\" ng-model=\"time.minute\" class=\"time-hour-input\"> <a class=\"btn\"><i class=\"fi fi-arrow-down\" ng-click=\"time.decreaseMinute()\"></i></a> </div> </div>";
        initGlobalTimeEvent = function () {
            var me;
            me = this;
            angular.element(document).on("click", function (event) {
                var targetEle;
                targetEle = event.srcElement || event.target;
                if (angular.isDefined(me.$rootScope.time.parasitic)) {
                    if (me.$rootScope.time.parasitic.find(targetEle).length !== 0) {
                        return;
                    }
                }
                if (me.element.find(targetEle).length === 0) {
                    me.$rootScope.$apply(function () {
                        me.timepaneStyle = {};
                    });
                }
            });
        };
        TimePane = (function () {
            function TimePane($compile, $rootScope, $parse) {
                this.$compile = $compile;
                this.$rootScope = $rootScope;
                this.$parse = $parse;
                this.template = timePaneTemplate;
                this.element = this.$compile(this.template)(this.$rootScope);
                this.isHour24 = true;

                /*绑定全局点击事件 */
                initGlobalTimeEvent.call(this);
            }


            /*刷新时间 */

            TimePane.prototype.refresh = function (showTime, parasitic, isHour24) {
                var timeInfo;
                if (angular.isDefined(showTime)) {
                    if (angular.isDate(showTime)) {
                        this.hour = date.getHours();
                        this.minute = date.getMinutes();
                    } else {
                        timeInfo = showTime.split(":");
                        this.hour = timeInfo[0];
                        this.minute = timeInfo[1];
                    }
                }
                this.keyflag = false;
                if (angular.isDefined(parasitic)) {
                    this.parasitic = parasitic;
                }
                if (angular.isDefined(isHour24)) {
                    this.isHour24 = isHour24;
                }
            };


            /*显示时间模块 */

            TimePane.prototype.showTimepane = function () {
                if (angular.isDefined(this.parasitic)) {
                    this.parasitic.append(this.element);
                    this.timepaneStyle = {
                        'display': 'block'
                    };
                }
            };


            /*增加小时 */

            TimePane.prototype.increaseHour = function () {
                var _hour;
                this.hour = this.hour || "00";
                _hour = parseInt(this.hour, 10) + 1;
                if (_hour < 0) {
                    _hour = 0;
                }

                /*24小时制的情况 */
                if (this.isHour24) {
                    if (_hour >= 24) {
                        _hour = 0;
                    }
                } else {
                    if (_hour >= 12) {
                        _hour = 0;
                    }
                }
                this.hour = _hour < 10 ? "0" + _hour : "" + _hour;
                this.change();
            };


            /*增加分钟 */

            TimePane.prototype.increaseMinute = function () {
                var _minute;
                this.minute = this.minute || "00";
                _minute = parseInt(this.minute, 10) + 1;
                if (_minute < 0) {
                    _minute = 59;
                }
                if (_minute == 60) {
                    _minute = 0;
                    this.increaseHour();
                }
                this.minute = _minute < 10 ? "0" + _minute : "" + _minute;
                this.change();
            };


            /*减少小时 */

            TimePane.prototype.decreaseHour = function () {
                var _hour;
                this.hour = this.hour || "00";
                _hour = parseInt(this.hour, 10) - 1;
                if (_hour < 0) {
                    if (this.isHour24) {
                        _hour = 23;
                    }else{
                        _hour = 11;
                    }

                }

                /*24小时制的情况 */
                if (this.isHour24) {
                    if (_hour >= 24) {
                        _hour = 23;
                    }
                } else {
                    if (_hour >= 12) {
                        _hour = 11;
                    }
                }
                this.hour = _hour < 10 ? "0" + _hour : "" + _hour;
                this.change();
            };


            /*减小分钟 */

            TimePane.prototype.decreaseMinute = function () {
                var _minute;
                this.minute = this.minute || "00";
                _minute = parseInt(this.minute, 10) - 1;
                if (_minute == -1) {
                    this.decreaseHour();
                    _minute = 59;
                }

                if (_minute >= 60) {
                    _minute = 59;
                }
                this.minute = _minute < 10 ? "0" + _minute : "" + _minute;
                this.change();
            };


            /*值改变回调定义 */

            TimePane.prototype.change = function (callback) {
                if (angular.isDefined(callback)) {
                    if (angular.isFunction(callback)) {
                        this.changeCallback = callback;
                        return;
                    } else {
                        this.changeCallback.call(this, callback);
                    }
                } else {
                    this.changeCallback.call(this, this.hour + ":" + this.minute);
                }
            };


            /*小时输入防止按住重复输入 */

            TimePane.prototype.hourKeyPress = function ($event) {
                var keyCode;
                keyCode = $event.keyCode;
                if (!(keyCode > 47 && keyCode < 58)) {
                    $event.preventDefault();
                    return;
                }
                if (this.keyflag) {
                    $event.preventDefault();
                } else {
                    this.keyflag = true;
                }
            };


            /*输入小时 */

            TimePane.prototype.hourKeyUp = function ($event) {
                var element, pos, value;
                element = angular.element($event.srcElement || $event.target);
                value = element.val();
                value = DBCUtils.toCDB(value);
                element.val(value);
                value = parseInt(value, 10);
                if (Number.isNaN(value)) {
                    value = 0;
                }
                if (value > 10) {
                    if (this.isHour24) {
                        if (value > 23 || value < 0) {
                            pos = CursorPositionUtil.getPosition(element);
                            CursorPositionUtil.removePositionChar(element, pos);
                            CursorPositionUtil.setPosition(element, pos - 1);
                        }
                    } else {
                        if (value > 11 || value < 0) {
                            pos = CursorPositionUtil.getPosition(element);
                            CursorPositionUtil.removePositionChar(element, pos);
                            CursorPositionUtil.setPosition(element, pos - 1);
                        }
                    }
                    value = parseInt(element.val(), 10);
                }
                this.hour = value < 10 ? "0" + value : "" + value;
                this.change();
                this.keyflag = false;
            };


            /*输入分钟 */

            TimePane.prototype.minuteKeyUp = function ($event) {
                var element, pos, value;
                element = angular.element($event.srcElement || $event.target);
                value = element.val();
                value = DBCUtils.toCDB(value);
                element.val(value);
                value = parseInt(value, 10);
                if (value > 59) {
                    pos = CursorPositionUtil.getPosition(element);
                    CursorPositionUtil.removePositionChar(element, pos);
                    CursorPositionUtil.setPosition(element, pos - 1);
                    value = element.val();
                    value = parseInt(value, 10);
                }
                if (Number.isNaN(value)) {
                    value = 0;
                }
                if (value > 10) {
                    if (value > 59 || value < 0) {
                        pos = CursorPositionUtil.getPosition(element);
                        CursorPositionUtil.removePositionChar(element, pos);
                        CursorPositionUtil.setPosition(element, pos - 1);
                    }
                    value = parseInt(element.val(), 10);
                }
                this.minute = value < 10 ? "0" + value : "" + value;
                this.change();
                this.keyflag = false;
            };


            /*分钟输入防止按住重复输入 */

            TimePane.prototype.minuteKeyPress = function ($event) {
                var keyCode;
                keyCode = $event.keyCode;
                if (!(keyCode > 47 && keyCode < 58)) {
                    $event.preventDefault();
                    return;
                }
                if (this.keyflag) {
                    $event.preventDefault();
                } else {
                    this.keyflag = true;
                }
            };

            return TimePane;

        })();
        return TimePane;
    });

}).
    call(this);
