/**
 * Created by zhengkui on 2015/10/17.
 */
define('framework/tmsparams/TmsParamsModule', [
    'angular',
    '../data/tms-params-config'
], function (angular, paramsConfig) {
    return angular.module('TmsParamsModule', [], ['$filterProvider', '$compileProvider', function ($filterProvider, $compileProvider) {
        var gParamsValue = angular.element('body').attr('tms-params'),
            filterFn = angular.noop,
            requested = false,
            paramsData,     //ajax返回的数据字典数据
            filterNames,  //过滤器数组名称
            params,
            i,len;

        //http请求调用初始化
        function requestFn($http, $rootScope) {
            if (!paramsData && requested === false) {
                requested = true;
                $http({
                    method:paramsConfig.method||'get',
                    url:window.basePath+paramsConfig.url+"?"+params,
                    data:paramsConfig.data || ''
                }).then(function (result) {
                    var $tmsParams = $rootScope.$tmsParams || {};
                    paramsData = result.data || [];
                    //返回的数据放入到$rootScope属性中，以便后续的获取
                    angular.forEach(paramsData, function(dictObj, paramKey){
                        $tmsParams[paramKey] = dictObj;
                    });
                    $rootScope.$tmsParams = $tmsParams;

                    filterFn = function (filterName, input, reverse) {
                        var data, key,value;
                        if($tmsParams) data = $tmsParams[filterName];
                        if (!data) return input;
                        for (i in data) {
                            if (data[i].key == input) return data[i].value;
                        }
                    }
                });
            }
        }

        if (!gParamsValue) return;
        filterNames = gParamsValue.split(',');
        len = filterNames.length;
        params = 'paramKey='+gParamsValue;
        if(paramsConfig.params) params = params;

        $compileProvider.directive('tmsParams', ['$http', '$rootScope', function($http, $rootScope){
            requestFn($http, $rootScope);
            return {
                restrict: 'A'
            };
        }]);

        //定义多个过滤器
        for (i=0;i<len;i++){
            (function (filerName) {
                $filterProvider.register(filerName, ['$http', '$rootScope',function($http, $rootScope){
                    requestFn($http, $rootScope);
                    return function(input, reverse) {
                        return filterFn(filerName, input, reverse);
                    }
                }]);
            })(filterNames[i]);
        }

    }]);
});