
define [
	"angular"
	"framework/upload/UploadModule"
	"framework/msg/GillionMsgModule"
	],(angular)->
	UploadGroupModule = angular.module "UploadGroupModule",["UploadModule","GillionMsgModule"]

	template = '<div class="form-upload">
					<div class="form-upload-item">
                        <button class="btn form-upload-btn-add">
                            <i class="fi fi-add"></i>
                            <span>上传文件</span>
                        </button>
                    </div>
					
					<div class="form-upload-item" state="uploading" ng-repeat="uploadFile in uploadFiles">
                        <button class="btn form-upload-btn-del"><i class="fi fi-close-xs"></i></button>
                        <div class="form-upload-icon">
                            <button class="btn form-upload-btn-icon">
                                <i class="fi fi-file-word"></i>
                            </button>
                            <div class="form-upload-item-mask">
                            </div>
                            <div class="form-upload-item-uploading">上传中</div>
                        </div>
                        <div class="form-upload-item-text">
                        </div>
                    </div>
					
					<g-upload
						file-marker="{{item.fileMarker}}"
						ng-repeat="item in items"
						file-name="{{item.fileInfo.fileName}}"
						file-id="{{item.fileInfo.id}}"
						image-show-url="{{item.imageShowUrl}}"
						>
					</g-upload>
				</div>'
				
	UploadGroupModule.directive "gUploadGroup",($http,$parse,Arrays,GillionMsg)->
		ngModelListener = ($scope,$ngModel,value)->
			if $scope.valueProp
				if angular.isArray value
					value = Arrays.extractToArray value,$scope.valueProp
				else
					value = value[$scope.valueProp]
			
			if angular.isDefined $ngModel
				if $ngModel.$viewValue != value
					if $scope.$root.$$phase
						$ngModel.$setViewValue value
					else
						$scope.$apply ->
							$ngModel.$setViewValue value
		defaultImageFileExtensions = ["bpm","png","jepg","gif","jpg"];
		isImageFile = (file)->
			ext = if -1 != file.indexOf('.') then file.replace(/.*[.]/, '')  else ''
			ext =  ext.toLowerCase()
			return defaultImageFileExtensions.indexOf(ext) != -1
		initEnv = ($scope)->
			$scope.limitTypeProp 	= $scope.limitTypeProp 	|| "limitType"
			$scope.limitSizeProp 	= $scope.limitSizeProp 	|| "limitSize"
			$scope.limitCountProp 	= $scope.limitCountProp || "limitCount"
			$scope.uploadTypeProp 	= $scope.uploadTypeProp || "uploadType"
			$scope.keyParam			= $scope.keyParam 		|| "key"
			$scope.imageShowUrlProp = $scope.imageShowUrlProp || "smallThumbnail"

			$scope.fileIdProp		= $scope.fileIdProp		|| "id"
			$scope.fileNameProp 	= $scope.fileNameProp 	|| "fileName"

			$scope.limitTypeGetter 	= $parse $scope.limitTypeProp
			$scope.limitSizeGetter 	= $parse $scope.limitSizeProp
			$scope.limitCountGetter = $parse $scope.limitCountProp
			$scope.uploadTypeGetter = $parse $scope.uploadTypeProp
			$scope.keyGetter		= $parse $scope.keyParam
			$scope.fileIdGetter     = $parse $scope.fileIdProp
			$scope.fileNameGetter    = $parse $scope.fileNameProp
			$scope.imageShowUrlGetter= $parse $scope.imageShowUrlProp

			$scope.keySetter		= $scope.keyGetter.assign
			$scope.fileIdSetter     = $scope.fileIdGetter.assign
			$scope.fileNameSetter   = $scope.fileNameGetter.assign

		return {
			template:template
			restrict:"E"
			scope:{
				key:"@"
				uploadInfoUrl:"@"
				uploadUrl:"@"
				deleteUrl:"@"

				beforeUpload:"&"
				onUpload:"&"

				valueProp:"@"
				deleteParams:"="

				keyParam:"@"
				limitTypeProp:"@"
				uploadTypeProp:"@"
				limitSizeProp:"@"
				limitCountProp:"@"

				###用于ngModel的解析与删除时的解析###
				fileIdProp:"@"	
				fileNameProp:"@"

				###用于有ngModel时，自动获取图片url进行显示###
				imageShowUrlProp:"@"

				###上传时想额外添加的数据###
				uploadExtraData:"="


			}
			require:["^?ngModel","^?gUploadGroup"]
			controller:($scope,$element,$attrs)->


				###1.初始化字段环境###
				initEnv $scope
				self = this
				fileIdProp = $scope.fileIdProp
				self.uploadFiles = []
				if !$scope.uploadUrl
					$scope.uploadUrl = $scope.uploadInfoUrl
				self.uploadUrl 	= $scope.uploadUrl

				if !$scope.deleteUrl
					$scope.deleteUrl = $scope.uploadInfoUrl

				self.deleteUrl = $scope.deleteUrl

				self.uploadExtraData = $scope.uploadExtraData
				self.key = $scope.key
				self.beforeUpload = $scope.beforeUpload
				self.onUpload = $scope.onUpload
				
				###加载上传信息###
				this.loadUploadInfo = (callback)->
					if !self.uploadInfo
						params = {}
						$scope.keySetter params,$scope.key
						$http.get.apply($scope,[$scope.uploadInfoUrl,{params:params}])
						.success	(data)->
							limitType 	= $scope.limitTypeGetter 	data
							limitSize 	= $scope.limitSizeGetter 	data
							limitCount 	= $scope.limitCountGetter 	data
							uploadType 	= $scope.uploadTypeGetter 	data
							self.uploadInfo = {
								limitType:limitType
								limitSize:limitSize
								limitCount:limitCount
								uploadType:uploadType
							}
							if angular.isFunction callback
								callback(self.uploadInfo)
					else
						callback(self.uploadInfo)

				
				this.addFile = (fileMarker,fileInfo)->
					self.uploadFiles.push {
						fileMarker:fileMarker
						fileInfo:fileInfo
					}
					fileInfos = Arrays.extract(self.uploadFiles,"fileInfo");
					ngModelListener($scope,self.$ngModel,fileInfos);
					return
				this.deleteFile = (fileMarker,callback)->
					for i in [0..self.uploadFiles.length-1] by 1
						if self.uploadFiles[i].fileMarker is fileMarker
							params = {}
							$scope.keySetter params,$scope.key
							params["fileInfo"]=self.uploadFiles[i].fileInfo
							params["fileIdProp"]= fileIdProp
							angular.extend params,$scope.deleteParams
							$http.post.apply($scope,[self.deleteUrl,params])
								.success (result)->
									if result.success
										self.uploadFiles.splice i,1
										if angular.isFunction callback
											callback()
										fileInfos = Arrays.extract(self.uploadFiles,"fileInfo");
										ngModelListener($scope,self.$ngModel,fileInfos);
							break
					return
				this.initialShowCount = $attrs.initialShowCount || 1;
				this.initialShowCount = parseInt(this.initialShowCount,10)
				this.addFileUpload = ()->
					if $scope.$root.$$phase
						lastItemFileMarker = $scope.items[$scope.items.length - 1]["fileMarker"]
						self.initialShowCount = parseInt(lastItemFileMarker,10) + 1
						$scope.items.push {"fileMarker":lastItemFileMarker + 1,fileInfo:{}}
					else
						$scope.$apply ->
							lastItemFileMarker = $scope.items[$scope.items.length - 1]["fileMarker"]
							self.initialShowCount = parseInt(lastItemFileMarker,10) + 1
							$scope.items.push {"fileMarker":lastItemFileMarker + 1,fileInfo:{}}
							return
					return
				return
			replace:true
			link:($scope,$element,$attr,$ctrl)->
				
				###1.设置ngModel###
				$ctrl[1].$ngModel = $ctrl[0]
				
				###2.根据默认数量显示数量###
				$attr.initialShowCount = $attr.initialShowCount || 1
				$attr.initialShowCount = parseInt($attr.initialShowCount,10)
				$scope.items = []
				for i in [1..$attr.initialShowCount] by 1
					$scope.items.push {"fileMarker":i,"fileInfo":{}}
				$ngModel = $ctrl[0]
				
				###3.双向绑定###
				if $ngModel
					$ngModel.$render = ->
						if !$ngModel.$isEmpty($ngModel.$viewValue)
							$scope.items = []
							if angular.isArray $ngModel.$viewValue
								showCount = if $ngModel.$viewValue.length > $attr.initialShowCount then $ngModel.$viewValue.length else $attr.initialShowCount;
								$ctrl[1].initialShowCount = showCount + 1
								for i in [1..showCount] by 1
									fileInfo = {}
									fileInfo["id"] = $scope.fileIdGetter $ngModel.$viewValue[i - 1]
									fileInfo["name"] = $scope.fileNameGetter $ngModel.$viewValue[i - 1]
									if i < $ngModel.$viewValue.length + 1

										if $ctrl[1].uploadType == "image" || isImageFile(fileInfo["name"])
											imageShowUrl = $scope.imageShowUrlGetter $ngModel.$viewValue[i - 1]

										$ctrl[1].uploadFiles.push ({
											"fileMarker":"#{i}",
											"fileInfo":fileInfo,
											"imageShowUrl":imageShowUrl
											})
									$scope.items.push {"fileMarker":i,"fileInfo":fileInfo,"imageShowUrl":imageShowUrl}
								if $attr.initialShowCount <= $ngModel.$viewValue.length
									$ctrl[1].addFileUpload()
							else
								for i in [1..$attr.initialShowCount] by 1
									if i == 1
										fileInfo = {}
										fileInfo["id"] = $scope.fileIdGetter $ngModel.$viewValue
										fileInfo["name"] = $scope.fileNameGetter $ngModel.$viewValue
										if $ctrl[1].uploadType == "image" || isImageFile(fileInfo["name"])
											imageShowUrl = $scope.imageShowUrlGetter $ngModel.$viewValue
										
										$scope.items.push {"fileMarker":"#{i}","fileInfo":fileInfo,"imageShowUrl":imageShowUrl}
										$ctrl[1].uploadFiles.push ({
											"fileMarker":i,
											"fileInfo":fileInfo,
											"imageShowUrl":imageShowUrl
											})
									else
										$scope.items.push {"fileMarker":"#{i}","fileInfo":{}}
								if $attr.initialShowCount == 1
									$ctrl[1].addFileUpload()
						

				return
					
					
		}