define [
	"angular"
	"framework/msg/GillionMsgModule"
	"underscore"
],(angular)->

	UploadModule = angular.module "UploadModule",["GillionMsgModule"]
	UploadDefaultSettings = {
		iconInfos:
			"fi-file-word":["docx","dotx","doc","dot","docm","xps","rtf","wtf","odt"]
			"fi-file-pdf":["pdf"]
			"fi-file-excel":["xlsx","xlsm","xlsb","xltx","xltm","xls","xlt","xls","xml","xlam","xla","xlw","csv"]
			"fi-file-ppt":["pptx","pptm","ppt","xps","potx","potm","pot","thmx","pps","ppsm","ppam","ppa"]
			"fi-file-rar":["rar","zip","zz","zix","zipx","z","yz","war","tgz","rpm","rz","jar","gzip"]
	}

	defaultImageFileExtensions = ["bpm","png","jepg","gif","jpg"];
	isImageFile = (ext)->
		return _.indexOf(defaultImageFileExtensions,ext) != -1
		
	if /msie/.test(navigator.userAgent.toLowerCase())
		isIE = true
	else
		isIE = false

	browserVersion= navigator.userAgent.toUpperCase();
	preview = (fileObj,imgContainer,divContainer)->
		fileObj = fileObj[0]
		if fileObj.files
			if window.FileReader
				reader = new FileReader()
			reader.onload = (e)->
				imgContainer.attr("src",e.target.result)

			reader.readAsDataURL fileObj.files[0]
		else if isIE
			fileObj.select()
			previewContainer = divContainer.find(".preview-container")
			imagePath = document.selection.createRange().text
			imgContainer[0].style.filter = "progid:DXImageTransform.Microsoft.AlphaImageLoader(sizingMethod='scale',src='#{imagePath}')";
		else if browserVersion.indexOf("FIREFOX") > -1
			firefoxVersion = parseFloat(browserVersion.toLowerCase().match(/firefox\/([\d.]+)/)[1])
			if firefoxVersion < 7
				imgContainer.attr "src",fileObj.files[0].getDatURL()
			else
				imgContainer.attr "src",window.URL.createObjectURL(fileObj.files[0])
		else
			imageShowSrc.attr "src",fileObj.val()
		return
		
	
	UploadModule.directive "gUpload",(Arrays,$timeout,GillionMsg)->

		class Uploader
				constructor: (@$scope,@$element,@$attr,@$uploadGroup) ->
					@action = @$uploadGroup.uploadUrl
					@uploadType = @$uploadGroup.uploadType
					###1.初始化时，先在控件上创建一个表单###
					@createInput()
					@settings = {
						responseType : @$attr.dataType || "json"
						data:{}
					}
					@uid = 0
					@Msg = angular.element(document).injector().get("GillionMsg")

				fileFromPath:(path)->
					return path.replace /.*(\/|\\)/, ""

				getExt:(file)->
					ext = if -1 != file.indexOf('.') then file.replace(/.*[.]/, '')  else '' 
					return  ext.toLowerCase()

				getIconClass:(file)->
					ext = @getExt file
					for key,value of UploadDefaultSettings.iconInfos
						for item in value
							if ext == item
								return key
					return
				getFileSize:()->
					if isIE
						###IE下不进行大小验证###
						fileSize = 0;
					else
						fileSize = @_input[0].files[0].size
					return fileSize / 1024
				clearImagePreview:()->
					uploadBtn = @$element.find(".form-upload-btn-img")
					#1.清除img src
					uploadBtn.find("img").attr("src","")
					uploadBtn.find("img").css("filter","");
					return

					
				###清除上传表单###
				clearInput:->
					if !@_input
						return
					@element.find(@_input).remove()
					@_input = null
					@createInput()
					

				###创建上传表单###
				createInput:->
					@_input = angular.element('<input name="upfile" type="file">')
					self = this
					self.uploadContainer = {
						settings:
							data:{}
					}
					@_input.on "change",->
						if !self._input or self._input.val() == ''
							return
						if self.$uploadGroup.beforeUpload
							if self.$uploadGroup.beforeUpload({"file":self._input.val(),"uploadContainer":self.uploadContainer}) == false
								return
						
						
						###从后台获取key###
						self.$uploadGroup.loadUploadInfo (uploadInfo)->
							###1.判断是否是指定类型###
							extension = self.getExt self._input.val()
							if !Arrays.exists uploadInfo.limitType,extension
								self.Msg.alert "提示信息","上传失败，上传的文件类型非法！"
								return

							###2.判断是否符合限定大小###
							size = self.getFileSize()
							if size > uploadInfo.limitSize
								self.Msg.alert "提示信息","上传失败，上传的文件超过最大大小：#{uploadInfo.limitSize}KB！"
								return
							
							###3.判断当前上传是否为最后一个，是否超过限定数量###
							if self.$uploadGroup.uploadFiles.length == uploadInfo.limitCount
								self.Msg.alert "提示信息","上传失败，上传的文件超过最大数量：#{uploadInfo.limitCount}！"
								return
							fileName =  self.fileFromPath self._input.val()
							changeStatus = ->
								if isImageFile(extension)
									self.$scope.fileType = 1
									divContainer = self.$element.find(".form-upload-btn-img")
									imgContainer = divContainer.find("img")
									preview(self._input,imgContainer,divContainer)
								else
									self.$scope.fileType = 0
									iconClass = self.getIconClass fileName
									self.$scope.fileIcon[iconClass] = true
								self.$scope.uploadStatus = 1
							if self.$scope.$root.$$phase
								changeStatus()
							else
								self.$scope.$apply changeStatus
							
							self.$element.find(".form-upload-item-text").html fileName
							self.$element.attr "state","uploading"
							###若选项不为空值，则进行上传操作###
							self.submit()
							return
						return
					@$element.append(this._input)

				###创建上传form###
				createForm:(iframe)->
					self = this
					form = angular.element('<form method="post" enctype="multipart/form-data"></form>')
					form.attr "action",@action
					form.attr "target",iframe.attr "name"
					form.css "display","none"
					angular.element(document.body).append form

					###创建需要提交的隐藏表单###

					@settings.data = {
						key:self.$uploadGroup.key
					}
					angular.extend @settings.data,self.$uploadGroup.uploadExtraData
					angular.extend @settings.data,self.uploadContainer.settings.data
					
					for key,value of @settings.data
						dataInput = angular.element('<input type="hidden">')
						dataInput.attr "name",key
						dataInput.attr "value",value
						form.append dataInput

					@settings.data={}
					return form


				###创建Iframe###
				createIframe:->
					@uid++
					iframe = angular.element '<iframe src="javascript:false;" />'
					iframe.attr "id",@uid
					iframe.attr "name",@uid
					iframe.css "display","none"
					angular.element(document.body).append iframe
					return iframe

				###获取响应###
				getResponse:(file)->
					self = this
					frame = @iframe[0]
					@iframe.on 'load',->
						if frame.src == "%3Chtml%3E%3C/html%3E;"|| frame.src == "javascript:'<html></html>"
							if deleteFlag
								setTimeout(->
									self.removeNode iframe
									,0)
							return
						doc = if frame.contentDocument then frame.contentDocument else window.frames[frame.id].document
						if doc.readyState && doc.readyState != 'complete'
							return
						if doc.body && doc.body.innerHtml == 'false'
							return
						if doc.XMLDocument
							response = doc.XMLDocument
						else if(doc.body)
							response = doc.body.innerHTML
							if self.settings.responseType && self.settings.responseType.toLowerCase() == 'json'
								if doc.body.firstChild && doc.body.firstChild.nodeName.toUpperCase() == 'PRE'
									response = doc.body.firstChild.firstChild.nodeValue
								if response
									try
										response = self.$scope.$eval response
										if !response.success
											self.Msg.alert("提示信息",response.errorMessages)
										
									catch e
										self.Msg.alert("提示信息","上传失败，请重新上传！")
										self.$scope.$apply ->
											self.$scope.uploadStatus = 0
											self.$element.find(".form-upload-item-text").html ""
											return
										self.iframe.remove();
										self.$element.removeAttr "state"
										self.iframe = null;
										if !self.$scope.fileType = 1
											self.clearImagePreview()
										self.createInput();
										return
									
								else
									response = {}
						else
							response = doc

						self.$scope.$emit("success",response);
						self.$uploadGroup.addFile self.$attr.fileMarker,response.data
						if self.$uploadGroup.onUpload
							self.$uploadGroup.onUpload({"fileInfo":response.data})
						

						###判断是否是最后一个文件，若是则判断显示的数量是否小于限制数量，若是，则新增一个上传项###
						if self.$uploadGroup.uploadFiles.length ==  self.$uploadGroup.initialShowCount and self.$uploadGroup.uploadFiles.length < self.$uploadGroup.uploadInfo.limitCount
							self.$uploadGroup.addFileUpload()
							
						self.$scope.$apply ->
							self.$scope.uploadStatus = 2
							return
						self.$element.removeAttr("state")
						self.iframe.remove();
						self.iframe = null;
						return

					@iframe.on 'error',->
						self.$scope.$apply ->
							self.$scope.uploadStatus = 0
							self.$element.find(".form-upload-item-text").html ""
							return
						self.clearImagePreview()
						deleteFlag = true
						iframe.remove();
						iframe = null;
						self.createInput();
						return
					return

				###上传文件###
				submit:->
					file = @fileFromPath @_input.val()
					@iframe = @createIframe()
					form = @createForm @iframe
					form.append this._input
					form.submit()
					form.remove()
					form = null

					@_input.remove()
					@_input = null
					@getResponse @iframe,file
		template = '<div class="form-upload-item">
				        <button class="btn form-upload-btn-add" ng-show="uploadStatus==0">
				            <i class="fi fi-add"></i>
				            <span>上传文件</span>
				        </button>
				        <button class="btn form-upload-btn-del" ng-show="uploadStatus!=0" ng-click="deleteFile($event)"><i class="fi fi-close-xs"></i></button>
                        <div class="form-upload-icon" ng-show="uploadStatus!=0">
                            <button class="btn form-upload-btn-icon" ng-show="fileType==0">
                                <i class="fi" ng-class="fileIcon"></i>
                            </button>
                            <button class="btn form-upload-btn-img" ng-show="fileType==1">
                                <img width="78" height="78">
                            </button>
                            <div class="form-upload-item-mask">
                            </div>
                            <div class="form-upload-item-uploading">上传中</div>
                        </div>

                        <div class="form-upload-item-text" ng-show="uploadStatus!=0">
                        </div>

				    </div>'
		return {
			template:template
			restrict:"E"
			scope:{
				fileKey:"@"
				name:"@"
				imageShowUrl:"@"
			}
			require:["^?gUploadGroup"]
			replace:true
			link:($scope,$element,$attr,$ctrls)->

				$uploadGroup = $ctrls[0]
				$scope.fileIcon={}

				uploader = new Uploader($scope,$element,$attr,$uploadGroup)

				$scope.uploadStatus = 0

				$scope.deleteFile = ($event)->
					$uploadGroup.deleteFile $attr.fileMarker,->
						$scope.uploadStatus = 0
						$element.removeAttr "state"
						$element.find(".form-upload-item-text").html ""
						if uploader.iframe
							uploader.iframe.remove();
							uploader.iframe = null;
						uploader.createInput();
						uploader.clearImagePreview();
						GillionMsg.alert("提示信息","删除成功！",undefined,{
							timeout:1000
							});
						return
					return

				
				###说明为已上传###
				if $scope.fileKey && $scope.name
					extension = uploader.getExt $scope.name
					if isImageFile(extension)
						$scope.fileType = 1
					else
						$scope.fileType = 0
					$element.find(".form-upload-item-text").html $scope.name
					if !isImageFile(extension)
						iconClass = uploader.getIconClass $scope.name
						$scope.fileIcon = {}
						$scope.fileIcon[iconClass]=true
					else
						$timeout ->
							$element.find(".form-upload-btn-img").find("img").attr "src",$scope.imageShowUrl
					$scope.uploadStatus = 2
					uploader._input.remove()
					uploader._input = null

				return

		}