require.config({
    baseUrl:'${baseUrl}/${version}/static/app',
    waitSeconds: 2000,
    paths: {
        "jquery"                :"${baseUrl}/${version}/bower_components/jquery.min",
        "angular"               :"${baseUrl}/${version}/bower_components/angular",
        "angular-route"         :"${baseUrl}/${version}/bower_components/angular-route.min",
        "angular-resource"      :"${baseUrl}/${version}/bower_components/angular-resource",
        "angular-local-storage" :"${baseUrl}/${version}/bower_components/angular-local-storage",
        "angular-base64"        :"${baseUrl}/${version}/bower_components/angular-base64",
        "tooltipster"           :"${baseUrl}/${version}/bower_components/jquery.tooltipster",
        "laydate"               :"${baseUrl}/${version}/bower_components/laydate.dev",
        'angular-sanitize'      :"${baseUrl}/${version}/bower_components/angular-sanitize",
        'ztree'                 :"${baseUrl}/${version}/bower_components/jquery.ztree.core-3.5.min",
        'ztree_check'           :"${baseUrl}/${version}/bower_components/jquery.ztree.excheck-3.5.min",
        'underscore'            :"${baseUrl}/${version}/bower_components/underscore",
        'angular-underscore'    :"${baseUrl}/${version}/bower_components/angular-underscore",
        'artTmpl'               :"${baseUrl}/${version}/bower_components/template-debug",
        'date-picker'           :"${baseUrl}/${version}/bower_components/laydate",
        'LodopFuncs'            :"${baseUrl}/${version}/bower_components/LodopFuncs6.1.9.8",
    },
    shim: {
        "angular": {
            exports: "angular",
            deps: ["jquery"]
        },
        "angular-underscore":{
            deps:["angular","underscore"]
        },
        "angular-resource": {
            deps: ["angular"]
        },
        "angular-route": {
            deps: ["angular"]
        },
        "angular-local-storage": {
            deps: ["angular"]
        },
        "angular-base64": {
            deps: ["angular"]
        },
        "tooltipster": {
            deps: ["jquery"]
        },
        "laydate": {
            exports: "laydate"
        },
        "angular-sanitize": {
            deps: ["angular"]
        },
        "ztree": {
            deps: ["jquery"]
        },
        "ztree_check": {
            deps: ["jquery", "ztree"]
        },
        'artTmpl': {
            exports: 'artTmpl'
        }
    },
    config: {
        i18n: {
            locale: 'zh-cn'
        }
    },
    deps: ["dynamicBootstrap"]
});