#各系统上下文配置说明

### 配置如下： 

参考以下内容更改 **config.properties.js** ， 路径： `${静态目录路径}/static/app/config.properties.js`

```javascript
define({
    //... 其它设置
    $paths: {
        $current: {
            ctx: 'http://www.gillion.com/gillion-web',
            path: 'http://www.gillion.com'
        },
        tms: {
            ctx: 'http://tms.kxtx.cn/kxtx-tms',
            path: 'http://tms.kxtx.cn'
        },
        oms: {
            ctx: 'http://oms.kxtx.cn/kxtx-oms',
            path: 'http://oms.kxtx.cn'
        },
        crm: {
            ctx: 'http://crm.kxtx.cn/kxtx-crm',
            path: 'http://crm.kxtx.cn'
        },
        wms: {
            ctx: 'http://wms.kxtx.cn/kxtx-wms',
            path: 'http://wms.kxtx.cn'
        }
    }
});
```


说明：

+ `ctx` 为 **tomcat服务器** 访问地址， `path` 为 **nginx代理的静态目录的地址**
+ `$current` 节点为当前系统的上下文根信息，其它系统请以缩写命名
+ `$path` 将赋值为 `$rootScope` 的属性， 在`页面` 或 `controller` 构造函数中均可使用。

### 在 `页面` 中使用方式：

```html
<body ng-controller="someController">
    <!-- 无作用域或继承作用域 -->
    <a ng-href="{{$paths.$current.ctx}}/module/entity/save"></a>
        
    <!-- 隔离作用域 -->
    <g-grid>
        <g-column>
            <g-column-tmpl>
                <a ng-href="{{$root.$paths.$current.ctx}}/module/entity/save"></a>
            </g-column-tmpl>    
        </g-column>
    </g-grid>
</body>
```

### 在 `controller` 构造函数中使用方式

```javascript
define(['angular', 'config.properties'], function(angular, config){
    // 通过 requirejs 依赖取得 $paths 对象
    var $paths = config.$paths,
        $currentPaths = $paths.$current,
        tmsPaths = $paths.tms;
    someModuleInstance.controller('controllerName', function($scope){
        $scope.setTmsMonitorLink = function(){
            $scope.tmsMonitorLink = tmsPaths.ctx + '/monitor/mainConsole';
        };
        
        // 或者通过 $rootScope
        var $paths = $scope.$root.$paths;
        //...
    });
});
```